<?php
/*
2004-06-10 20:40:30
*/
/* include_once 'functions-formatting.php'; */








function auto_thumbnail($img)
{
    global $thumbnail_quality, $thumbnail_size, $path_photos, $thumbnail_prefix;


    // beg-hack: so function can be used in admin or display mode
    $pre_slash = '../';
    if (!file_exists('../'.$path_photos.$img)) {
        $pre_slash = '';
    }
    $image_path = $pre_slash.$path_photos.$img;
    // end-hack


    $size = getimagesize($image_path);


    if ($size[0] > $size[1]) {
        // c
        $c_src_y = 0;
        $c_src_x = intval(($size[0] - $size[1])/2);

        $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

        // center thumbnail
        $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
        imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[1], $size[1]);
        imagejpeg($c_thumb, $pre_slash.$path_photos.$thumbnail_prefix.$img, $thumbnail_quality);
        imagedestroy($c_thumb);

        imagedestroy($src_img);


    } elseif ($size[0] < $size[1]) {
        // c
        $c_src_y = intval(($size[1] - $size[0])/2);
        $c_src_x = 0;

        $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

        // center thumbnail
        $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
        imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
        imagejpeg($c_thumb, $pre_slash.$path_photos.$thumbnail_prefix.$img, $thumbnail_quality);
        imagedestroy($c_thumb);

        imagedestroy($src_img);


    } elseif ($size[0] == $size[1]) {
        // c
        $c_src_y = 0;
        $c_src_x = 0;

        $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

        // center thumbnail
        $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
        imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
        imagejpeg($c_thumb, $pre_slash.$path_photos.$thumbnail_prefix.$img, $thumbnail_quality);
        imagedestroy($c_thumb);

        imagedestroy($src_img);

    }


    return 1;
}







// function from Joe Hughes <joe@retrovirus.com>, thanks Joe!
function resize_image($img, $max_size)
{
    global $thumbnail_quality, $thumbnail_size, $path_photos, $thumbnail_prefix;

    $image_path = '../'.$path_photos.$img;

    $size = getimagesize($image_path);

    $width = 0;
    $height = 0;

    if ($size[0] > $size[1]) { //! check for integer values !TODO
        $width = $max_size;
        $height = intval($size[1] * ($width/$size[0]));
    } elseif ($size[0] < $size[1]) {
        $height = $max_size;
        $width = intval($size[0] * ($height/$size[1]));
    } else {
        $width = $max_size;
        $height = $max_size;
    }


        $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

        $c_thumb = imagecreatetruecolor($width, $height);
        imagecopyresampled($c_thumb, $src_img, 0, 0, 0, 0, $width, $height, $size[0], $size[1]);
        imagejpeg($c_thumb, '../'.$path_photos.$img, $thumbnail_quality);
        imagedestroy($c_thumb);

        imagedestroy($src_img);

    return 1;
}







/*
This can be discarded by checking for $a and $i variables, then
digging for what we need. 2005-05-15 (Sunday)
*/
function get_cover_id($album_slug) //sql
{
   /*  global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $db_albums, $db_photos, $db_uploads, $path_db; */
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $table_albums, $table_photos, $table_uploads;

    $sql = " SELECT p.ID "
            ." FROM $table_albums a "
            ." LEFT JOIN $table_photos p ON a.cover_image=p.ID "
            ." WHERE a.slug='$album_slug' ";
    $img_id = $db->get_var($sql);
    if (!$img_id) {
        $album_id = $db->get_var(" SELECT ID FROM $table_albums WHERE slug='$album_slug' ");
        $sql = " SELECT MIN(ID) "
                ." FROM $table_photos "
                ." WHERE album_id='$album_id' "
                ." AND visible='Y' ";
        $img_id = $db->get_var($sql);
    }

    return $img_id;
}












//*  GET ALBUMS  -----------------------------------------------------------
function get_albums_for_frontpage()
{
    global $use_old_tags;

    if ($use_old_tags) { // support for old tags & templates
        $albums = __08_get_album_list_frontpage();
    } else {
        $albums = __09_get_album_list_frontpage();
    }
    // show variable info
    //ipap_debug($albums);

    return $albums;
}






function get_albums_for_label()
{
    global $use_old_tags, $l;
    if ($use_old_tags) { // support for old tags & templates
        $albums = __08_get_album_list_labeled($l);
    } else {
        $albums = __09_get_album_list_labeled($l);
    }
    // show variable info
    //ipap_debug($albums);

    return $albums;
}



function get_thumbnails_for_album()
{
    global $use_old_tags, $a;

    if ($use_old_tags) { // support for old tags & templates
        $thumbnails = __08_get_thumbnail_list($a);
    } else {
        $thumbnails = __09_get_thumbnail_list($a);
    }
    // show variable info
    //ipap_debug($thumbnails);

    return $thumbnails;
}


function get_current_photo()
{
    global $use_old_tags, $a, $i;
    if ($use_old_tags) { // support for old tags & templates
        $current_photo = __08_get_current_photo($a, $i);
    } else {
        $current_photo = __09_get_current_photo($a, $i);
    }
    // show variable info
    //ipap_debug($current_photo);

    return $current_photo;
}



function get_album_info()
{
    global $use_old_tags, $a;
    if ($use_old_tags) { // support for old tags & templates
        $album = __08_get_album_info($a);
    } else {
        $album = __09_get_album_info($a);
    }
    // show variable info
    //ipap_debug($album);

    return $album;
}



/*
function get_next_photo()
{

}


function get_prev_photo()
{

}

 */



function get_label_list()
{
    global $use_old_tags;
    if ($use_old_tags) { // support for old tags & templates
        $labels = __08_get_label_list();
    } else {
        $labels = __09_get_label_list();
    }
    // show variable info
    //ipap_debug($labels);

    return $labels;
}





function get_label_list_csv() //sql
{
    $labels = __08_get_label_list();


    if ($labels) {
        $p = '<p id="labels"><strong>Labels:</strong> ';
        $i = 0;

        foreach ($labels as $label) {
            $p = $p.'<a href="'.$label['link'].'" id="label-'.$label['ID'].'" title="'.$label['description_nohtml'].'">'.$label['name'].'</a>';
            if ($i+1 < count($labels)) {
                $p = $p.', ';
            }
            $i++;
        }
        $p = $p.'</p>';
    } else {
        $p = '';
    }


    return $p;
}






function get_current_label($label)
{
    global $db, $use_old_tags, $table_labels;

    $curr_label_id = $db->get_var(" SELECT ID FROM $table_labels WHERE slug='$label' ");

    if ($use_old_tags) { // support for old tags & templates
        $curr_label['id'] = $curr_label_id;
        $curr_label['ID'] = $curr_label_id;
    } else {
        $curr_label->id = $curr_label_id;
        $curr_label->ID = $curr_label_id;
    }
    // show variable info
    //ipap_debug($curr_label);

    return $curr_label;
/*
    global $db, $path_db, $db_labels;

    $db->open($path_db.$db_labels);
    $this_label = $db->select('slug', $label);
    $db->close();
        //echo '<pre>'; print_r($this_label); echo '</pre>';

    return $this_label[0];
 */
}



function get_labels_for_album()
{
    global $db, $a, $use_old_tags, $table_labels, $table_labelsrel, $table_albums, $use_mod_rewrite, $gallery_url;

    $sql = " SELECT l.label,l.description,l.slug,l.ID  "
            ." FROM $table_labelsrel r "
            ." LEFT JOIN $table_labels l "
            ." ON r.label_id=l.ID "
            ." LEFT JOIN $table_albums a "
            ." ON r.album_id=a.ID "
            ." WHERE l.visible='Y' "
            ." AND a.slug='$a' "
            ." ORDER BY r.sort_order ASC ";
    $this_labels = $db->get_results($sql);
    

    $i = 0;
    foreach ($this_labels as $label) {

        $label_list[$i]->ID = $label->ID;

        $label_list[$i]->name_raw = $label->label;
        $label_list[$i]->name = apply_filters('label_title', $label->label);

        $label_list[$i]->description_raw = $label->description;
        $label_list[$i]->description =  apply_filters('label_description', $label->description);

        if ($use_mod_rewrite) {
            $label_list[$i]->link = $gallery_url.'labels/'.$label->slug.'/';
        } else {
            $label_list[$i]->link = $gallery_url.'?l='.$label->slug;
        }

        $i++;
    }

    // show variable info
    //ipap_debug($label_list);

    return $label_list;
}




function get_labels_for_album_csv()
{
    $labels = get_labels_for_album();

    if ($labels) {
        $p = '<p class="labeled-as">Labeled as: ';
        $i = 0;
        foreach ($labels as $label) {
            $p = $p.'<a href="'.$label->link.'" id="label-'.$label->ID.'" title="'.short_alt($label->description_raw).'">'.$label->name.'</a>';
            if ($i+1 < count($labels)) {
                $p = $p.', ';
            }
            $i++;
        }
        $p = $p.'</p>';
    } else {
        $p = '';
    }
    
    
    return $p;
}











//*  09 GET  ---------------------------------------------------------------
function __09_get_album_list_frontpage()
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $table_albums, $table_photos, $table_uploads, $thumbnail_prefix, $path_photos;

    $sql = " SELECT a.ID, a.title, a.description, a.date_edited, a.date_created, a.slug, u.filename "
            ." FROM $table_albums a  "
            ." LEFT JOIN $table_photos p "
            ." ON  a.cover_image=p.ID "
            ." LEFT JOIN $table_uploads u "
            ." ON  p.upload_id=u.ID "
            ." WHERE a.visible='Y' "
            ." AND a.in_frontpage='Y' "
            ." ORDER BY a.sort_order DESC ";
    $albums = $db->get_results($sql);

    // show variable info
    //ipap_debug($albums);


    if ($albums) {
        $i = 0;
        foreach ($albums as $album) {

            $album_list[$i]->title_raw = $album->title;
            $album_list[$i]->title = apply_filters('album_title', $album->title);
            $album_list[$i]->description_raw = $album->description;
            $album_list[$i]->description = apply_filters('album_description', $album->description);
            $album_list[$i]->date_edited_raw = $album->date_edited;
            $album_list[$i]->date_edited = apply_filters('album_date_edited', date($gallery_date_format,  strtotime($album->date_edited)));
            $album_list[$i]->date_created_raw = $album->date_created;
            $album_list[$i]->date_created = apply_filters('album_date_created', date($gallery_date_format,  strtotime($album->date_created)));

            // get cover_image by ID if not set
            if ( '' == $album->filename ) {
                $sql = " SELECT ID FROM $table_photos "
                        ." WHERE album_id='$album->ID' "
                        ." ORDER BY sort_order ASC ";
                $min_id = $db->get_var($sql);

                $sql = " SELECT u.filename "
                        ." FROM $table_photos p "
                        ." LEFT JOIN $table_uploads u ON p.upload_id=u.ID "
                        ." WHERE p.ID='$min_id' ";
                $album_list[$i]->filename = $db->get_var($sql);
            } else {
                $album_list[$i]->filename = $album->filename;
            }

            $album_list[$i]->cover_image_thumbnail = $gallery_url.$path_photos.$thumbnail_prefix.$album_list[$i]->filename;

            // create thumbnail if not present
            if (!file_exists($path_photos.$thumbnail_prefix.$album_list[$i]->filename)) {
                auto_thumbnail($album_list[$i]->filename);
            }

            $album_list[$i]->cover_image = $gallery_url.$path_photos.$album_list[$i]->filename;
            $album_list[$i]->photo_count = $db->get_var(" SELECT COUNT(*) FROM $table_photos WHERE album_id='$album->ID' AND visible='Y' ");

            if ($use_mod_rewrite) {
                $album_list[$i]->link = $gallery_url.$album->slug.'/';
            } else {
                $album_list[$i]->link = $gallery_url.'?a='.$album->slug;
            }

            $album_list[$i]->id = $album->ID;
            $album_list[$i]->ID = $album->ID;

            $i++;
        }
    }
    // show variable info
    //ipap_debug($album_list);

    return $album_list;
}










function __09_get_album_list_labeled($label)
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $table_labels, $table_labelsrel, $table_albums, $table_photos, $table_uploads, $thumbnail_prefix, $path_photos;

    $label_id = $db->get_var(" SELECT ID from $table_labels WHERE slug='$label' ");

    $sql = " SELECT a.ID, a.title, a.description, a.date_edited, a.date_created, a.slug, u.filename "
            ." FROM $table_labelsrel r "
            ." LEFT JOIN $table_albums a  "
            ." ON  r.album_id=a.ID "
            ." LEFT JOIN $table_photos p "
            ." ON  a.cover_image=p.ID "
            ." LEFT JOIN $table_uploads u "
            ." ON  p.upload_id=u.ID "
            ." WHERE r.label_id='$label_id' "
            ." AND a.visible='Y' "
            ." ORDER BY r.sort_order DESC ";
    $albums = $db->get_results($sql);

    // show variable info
    //ipap_debug($albums);


    if ($albums) {
        $i = 0;
        foreach ($albums as $album) {

            $album_list[$i]->title_raw = $album->title;
            $album_list[$i]->title = apply_filters('album_title', $album->title);
            $album_list[$i]->description_raw = $album->description;
            $album_list[$i]->description = apply_filters('album_description', $album->description);
            $album_list[$i]->date_edited_raw = $album->date_edited;
            $album_list[$i]->date_edited = apply_filters('album_date_edited', date($gallery_date_format,  strtotime($album->date_edited)));
            $album_list[$i]->date_created_raw = $album->date_created;
            $album_list[$i]->date_created = apply_filters('album_date_created', date($gallery_date_format,  strtotime($album->date_created)));

            // get cover_image by ID if not set
            if ( '' == $album->filename ) {
                $sql = " SELECT ID FROM $table_photos "
                        ." WHERE album_id='$album->ID' "
                        ." ORDER BY sort_order ASC ";
                $min_id = $db->get_var($sql);

                $sql = " SELECT u.filename "
                        ." FROM $table_photos p "
                        ." LEFT JOIN $table_uploads u ON p.upload_id=u.ID "
                        ." WHERE p.ID='$min_id' ";
                $album_list[$i]->filename = $db->get_var($sql);
            } else {
                $album_list[$i]->filename = $album->filename;
            }

            $album_list[$i]->cover_image_thumbnail = $gallery_url.$path_photos.$thumbnail_prefix.$album_list[$i]->filename;

            // create thumbnail if not present
            if (!file_exists($path_photos.$thumbnail_prefix.$album_list[$i]->filename)) {
                auto_thumbnail($album_list[$i]->filename);
            }

            $album_list[$i]->cover_image = $gallery_url.$path_photos.$album_list[$i]->filename;
            $album_list[$i]->photo_count = $db->get_var(" SELECT COUNT(*) FROM $table_photos WHERE album_id='$album->ID' AND visible='Y' ");

            //$album_list[$i]['sanitized_name'] = $album_list[$i]['slug'];  // for backward-compatibilty

            if ($use_mod_rewrite) {
                $album_list[$i]->link = $gallery_url.$album->slug.'/';
            } else {
                $album_list[$i]->link = $gallery_url.'?a='.$album->slug;
            }

            $album_list[$i]->id = $album->ID;
            $album_list[$i]->ID = $album->ID;


            $i++;
        }
    }


    // show variable info
    //ipap_debug($album_list);

    return $album_list;
}









/* ==========================================
    template function
    $internal_use = used in get_current_photo()
 ========================================== */
function __09_get_thumbnail_list($album_slug, $internal_use = false) //sql
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $table_albums, $table_photos, $table_uploads, $thumbnail_prefix, $path_photos, $url_zeroise;

    $sql = " SELECT u.filename, u.width, u.height, u.date_uploaded, p.ID, p.title, p.caption, p.date_taken, p.date_edited, p.date_created "
            ." FROM $table_photos p "
            ." LEFT JOIN $table_uploads u ON p.upload_id=u.ID "
            ." LEFT JOIN $table_albums a ON p.album_id=a.ID "
            ." WHERE a.slug='$album_slug' "
            ." ORDER BY p.sort_order ASC ";
    $album_photos = $db->get_results($sql);

    // show variable info
    //ipap_debug($album_photos);


    if ($album_photos) {
        $i = 0;
        foreach ($album_photos as $photo) {

            //$photos[$i]->filename = $photo->filename;
            $photos[$i]->width = $photo->width;
            $photos[$i]->height = $photo->height;
            $photos[$i]->date_uploaded = $photo->date_uploaded;
            $photos[$i]->image = $gallery_url.$path_photos.$thumbnail_prefix.$photo->filename;

            // create thumbnail if not present
            if (!file_exists($gallery_url.$path_photos.$thumbnail_prefix.$photo->filename)) {
                auto_thumbnail($photo->filename);
            }

            if ($use_mod_rewrite) {
                $photos[$i]->link = $gallery_url.$album_slug.'/'.zeroise($photo->ID, $url_zeroise).'/';
            } else {
                $photos[$i]->link = $gallery_url.'?a='.$album_slug.'&amp;i='.$photo->ID;
            }

            $photos[$i]->title_raw = $photo->title;
            $photos[$i]->title = apply_filters('photo_title', $photo->title);
            $photos[$i]->caption_raw = $photo->caption;
            $photos[$i]->caption = apply_filters('photo_caption', $photo->caption);
            $photos[$i]->date_taken_raw = $photo->date_taken;
            $photos[$i]->date_taken = apply_filters('photo_date_taken', date($gallery_date_format,  strtotime($photo->date_taken)));
            $photos[$i]->date_edited_raw = $photo->date_edited;
            $photos[$i]->date_edited = apply_filters('photo_date_edited', date($gallery_date_format,  strtotime($photo->date_edited)));
            $photos[$i]->date_created_raw = $photo->date_created;
            $photos[$i]->date_created = apply_filters('photo_date_created', date($gallery_date_format,  strtotime($photo->date_created)));

            $photos[$i]->id = $photo->ID;
            $photos[$i]->ID = $photo->ID;

            //unset($photos[$i]->filename);

           /*  if (!$internal_use) {
                // unset unused tags
                unset($photos[$i]['visible']);
                unset($photos[$i]['sort_order']);
                unset($photos[$i]['upload_id']);
                unset($photos[$i]['album_id']);
                unset($photos[$i]['filename']);
                unset($photos[$i]['date_uploaded']);
                unset($photos[$i]['thumbnail']);
                unset($photos[$i]['width']);
                unset($photos[$i]['height']);
            } */
            $i++;
        }
    }
    // show variable info
    //ipap_debug($photos);

    return $photos;
}












function __09_get_current_photo($a, $i)
{
    global $db, $gallery_url, $path_photos, $table_photos, $table_albums;

    $photos = __08_get_thumbnail_list($a, 1);

    // show variable info
    //ipap_debug($photos);

    if ($i < 1) {
        $sql = " SELECT MIN(p.ID) "
                ." FROM $table_albums a "
                ." LEFT JOIN $table_photos p ON a.ID=p.album_id "
                ." WHERE a.slug='$a' "
                ." GROUP BY p.ID "
                ." ORDER BY p.sort_order ASC ";
        $img_id = $db->get_var($sql);
    // show variable info
    //ipap_debug($img_id);
    } else {
        $img_id = $i;
    }



    $found = 0;
    for ($i=0; $i < count($photos); $i++) {
        if ($photos[$i]['id'] == $img_id) {
            $found = 1;

            $current_photo = '';
            $current_photo->ID = $photos[$i]['id'];
            $current_photo->id = $photos[$i]['id'];
            $current_photo->filename = $photos[$i]['filename'];
            $current_photo->width = $photos[$i]['width'];
            $current_photo->height = $photos[$i]['height'];
            $current_photo->date_uploaded = $photos[$i]['date_uploaded'];
            $current_photo->title = $photos[$i]['title'];
            $current_photo->title_raw = $photos[$i]['title_raw'];
            /* rev3.1 -- $current_photo->title_nohtml = $photos[$i]['title_nohtml']; -- rev3.1 */
            $current_photo->caption = $photos[$i]['caption'];
            $current_photo->caption_raw = $photos[$i]['caption_raw'];
            /* rev3.1 -- $current_photo->caption_nohtml = $photos[$i]['caption_nohtml']; -- rev3.1 */
            /* rev3.1 -- $current_photo->caption_excerpt_nohtml = $photos[$i]['caption_excerpt_nohtml']; -- rev3.1 */
            $current_photo->date_taken = $photos[$i]['date_taken'];
            $current_photo->date_edited = $photos[$i]['date_edited'];
            $current_photo->date_created = $photos[$i]['date_created'];
            //$current_photo->image = $photos[$i]['image'];
            $current_photo->thumbnail = $photos[$i]['image'];
            $current_photo->link = $photos[$i]['link'];

            $current_photo->filesize_kb = round(filesize($path_photos.$photos[$i]['filename'])/1024, 2);
            $current_photo->image = $gallery_url.$path_photos.$photos[$i]['filename'];
            $current_photo->permalink = $photos[$i]['link'];


    // show variable info
    //ipap_debug($current_photo);


            if (isset($photos[$i+1])) {
                $current_photo->next_link = $photos[$i+1]['link'];
                $current_photo->next_image_thumbnail = $photos[$i+1]['image'];
                $current_photo->next_title_raw = $photos[$i+1]['title_raw'];
                /* rev3.1 -- $current_photo->next_title_nohtml = $photos[$i+1]['title_nohtml']; -- rev3.1 */
                $current_photo->next_title = $photos[$i+1]['title'];
                /* rev3.1 -- $current_photo->next_caption_excerpt_nohtml = $photos[$i+1]['caption_excerpt_nohtml']; -- rev3.1 */
                $current_photo->next_caption_raw = $photos[$i+1]['caption_raw'];
                /* rev3.1 -- $current_photo->next_caption_nohtml = $photos[$i+1]['caption_nohtml']; -- rev3.1 */
                $current_photo->next_caption = $photos[$i+1]['caption'];
            }
            if (isset($photos[$i-1])) {
                $current_photo->prev_link = $photos[$i-1]['link'];
                $current_photo->prev_image_thumbnail = $photos[$i-1]['image'];
                $current_photo->prev_title_raw = $photos[$i-1]['title_raw'];
                /* rev3.1 -- $current_photo->prev_title_nohtml = $photos[$i-1]['title_nohtml']; -- rev3.1 */
                $current_photo->prev_title = $photos[$i-1]['title'];
                /* rev3.1 -- $current_photo->prev_caption_excerpt_nohtml = $photos[$i-1]['caption_excerpt_nohtml']; -- rev3.1 */
                $current_photo->prev_caption_raw = $photos[$i-1]['caption_raw'];
                /* rev3.1 -- $current_photo->prev_caption_nohtml = $photos[$i-1]['caption_nohtml']; -- rev3.1 */
                $current_photo->prev_caption = $photos[$i-1]['caption'];
            }






            // remove unused tags
            //unset($current_photo['id']); added again for CSS unique ID
//            unset($current_photo['upload_id']);
//            unset($current_photo['album_id']);
//            unset($current_photo['sort_order']);
//            unset($current_photo['filename']);
//            unset($current_photo['thumbnail']);
//            unset($current_photo['date_uploaded']);
//            unset($current_photo['visible']);
            //unset($current_photo['link']);


            break;
        }
    }

    // show variable info
    //ipap_debug($current_photo);


    if (!$found) {
        return 0;
    } else {
        return $current_photo;
    }
}







function __09_get_label_list()
{
    global $db, $use_mod_rewrite, $gallery_url, $table_labels;

    $sql = " SELECT ID, label, slug, description "
            ." FROM $table_labels "
            ." WHERE visible='Y' "
            ." ORDER BY sort_order ASC ";
    $labels = $db->get_results($sql);

    $i = 0;
    foreach ($labels as $label) {

        $label_list[$i]->ID = $label->ID;

        $label_list[$i]->name_raw = $label->label;
        $label_list[$i]->name = apply_filters('label_title', $label->label);

        $label_list[$i]->description_raw = $label->description;
        $label_list[$i]->description =  apply_filters('label_description', $label->description);

        if ($use_mod_rewrite) {
            $label_list[$i]->link = $gallery_url.'labels/'.$label->slug.'/';
        } else {
            $label_list[$i]->link = $gallery_url.'?l='.$label->slug;
        }

        $i++;
    }

    // show variable info
    //ipap_debug($label_list);

    return $label_list;

}







function __09_get_album_info($album_slug)
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $table_albums, $table_photos;

    $sql = " SELECT ID, title, sort_order, slug, description, date_created, date_edited "
            ." FROM $table_albums "
            ." WHERE slug='$album_slug' ";
    $album = $db->get_row($sql);


    $album_info->ID = $album->ID;

    $album_info->title_raw = $album->title;
    $album_info->title =apply_filters('album_title', $album->title);

    $album_info->description_raw = $album->description;
    $album_info->description = apply_filters('album_description', $album->description);

    $album_info->date_edited_raw = $album->date_edited;
    $album_info->date_edited = apply_filters('album_date_edited', date($gallery_date_format,  strtotime($album->date_edited)));
    $album_info->date_created_raw = $album->date_created;
    $album_info->date_created = apply_filters('album_date_created', date($gallery_date_format,  strtotime($album->date_created)));

    $album_info->photo_count = $db->get_var(" SELECT COUNT(*) FROM $table_photos WHERE album_id='$album->ID' AND visible='Y' ");
    $album_info->sanitized_name = $album_info->slug; // for backward-compatibilty

    if ($use_mod_rewrite) {
        $album_info->link = $gallery_url.$album->slug.'/';
    } else {
        $album_info->link = $gallery_url.'?a='.$album->slug;
    }

    $album_info->permalink = $album_info->link;

    return $album_info;
}






//*  08 GET  ---------------------------------------------------------------


function __08_get_album_list_frontpage()
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $table_albums, $table_photos, $table_uploads, $thumbnail_prefix, $path_photos, $truncate_length;

    $sql = " SELECT a.ID, a.title, a.description, a.date_edited, a.date_created, a.slug, u.filename "
            ." FROM $table_albums a  "
            ." LEFT JOIN $table_photos p "
            ." ON  a.cover_image=p.ID "
            ." LEFT JOIN $table_uploads u "
            ." ON  p.upload_id=u.ID "
            ." WHERE a.visible='Y' "
            ." AND a.in_frontpage='Y' "
            ." ORDER BY a.sort_order DESC ";
    $albums = $db->get_results($sql);

    // show variable info
    //ipap_debug($albums);



    if ($albums) {
        $i = 0;
        foreach ($albums as $album) {

            $album_list[$i] = get_object_vars($album);

            // show variable info
            //ipap_debug($album_list[$i]);

            $album_list[$i]['title_raw'] = $album_list[$i]['title'];
            $album_list[$i]['title_nohtml'] = texturize(strip_tags($album_list[$i]['title']));
            $album_list[$i]['title'] = texturize($album_list[$i]['title']);
            $album_list[$i]['description_excerpt_nohtml'] = truncate(texturize(strip_tags($album_list[$i]['description'])), $truncate_length);
            $album_list[$i]['description_raw'] = $album_list[$i]['description'];
            $album_list[$i]['description_nohtml'] = texturize(strip_tags($album_list[$i]['description']));
            $album_list[$i]['description'] = autop(texturize($album_list[$i]['description']));
            $album_list[$i]['date_edited'] = date($gallery_date_format,  strtotime($album_list[$i]['date_edited']));
            $album_list[$i]['date_created'] = date($gallery_date_format,  strtotime($album_list[$i]['date_created']));

            // get cover_image by ID if not set
            if ( '' == $album_list[$i]['filename'] ) {
                $sql = " SELECT ID FROM $table_photos "
                        ." WHERE album_id='{$album_list[$i]['ID']}' "
                        ." ORDER BY sort_order ASC ";
                $min_id = $db->get_var($sql);

                $sql = " SELECT u.filename "
                        ." FROM $table_photos p "
                        ." LEFT JOIN $table_uploads u ON p.upload_id=u.ID "
                        ." WHERE p.ID='$min_id' ";
                $album_list[$i]['filename'] = $db->get_var($sql);
            }

            $album_list[$i]['cover_image_thumbnail'] = $gallery_url.$path_photos.$thumbnail_prefix.$album_list[$i]['filename'];

            // create thumbnail if not present
            if (!file_exists($path_photos.$thumbnail_prefix.$album_list[$i]['filename'])) {
                auto_thumbnail($album_list[$i]['filename']);
            }

            $album_list[$i]['cover_image'] = $gallery_url.$path_photos.$album_list[$i]['filename'];
            $album_list[$i]['photo_count'] = $db->get_var(" SELECT COUNT(*) FROM $table_photos WHERE album_id='".$album_list[$i]['ID']."' AND visible='Y' ");

            $album_list[$i]['sanitized_name'] = $album_list[$i]['slug'];  // for backward-compatibilty

            if ($use_mod_rewrite) {
                $album_list[$i]['link'] = $gallery_url.$album_list[$i]['slug'].'/';
            } else {
                $album_list[$i]['link'] = $gallery_url.'?a='.$album_list[$i]['slug'];
            }

            $album_list[$i]['id'] = $album_list[$i]['ID'];

            $i++;
        }
    }


    // show variable info
    //ipap_debug($album_list);

    return $album_list;
}











function __08_get_album_list_labeled($label)
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $table_labels, $table_labelsrel, $table_albums, $table_photos, $table_uploads, $thumbnail_prefix, $path_photos, $truncate_length;

    $label_id = $db->get_var(" SELECT ID from $table_labels WHERE slug='$label' ");

    $sql = " SELECT a.ID, a.title, a.description, a.date_edited, a.date_created, a.slug, u.filename "
            ." FROM $table_labelsrel r "
            ." LEFT JOIN $table_albums a  "
            ." ON  r.album_id=a.ID "
            ." LEFT JOIN $table_photos p "
            ." ON  a.cover_image=p.ID "
            ." LEFT JOIN $table_uploads u "
            ." ON  p.upload_id=u.ID "
            ." WHERE r.label_id='$label_id' "
            ." AND a.visible='Y' "
            ." ORDER BY r.sort_order DESC ";
    $albums = $db->get_results($sql);

    // show variable info
    //ipap_debug($albums);


    if ($albums) {
        $i = 0;
        foreach ($albums as $album) {

            $album_list[$i] = get_object_vars($album);
            // show variable info
            //ipap_debug($album_list[$i]);

            $album_list[$i]['title_raw'] = $album_list[$i]['title'];
            $album_list[$i]['title_nohtml'] = texturize(strip_tags($album_list[$i]['title']));
            $album_list[$i]['title'] = texturize($album_list[$i]['title']);
            $album_list[$i]['description_excerpt_nohtml'] = truncate(texturize(strip_tags($album_list[$i]['description'])), $truncate_length);
            $album_list[$i]['description_raw'] = $album_list[$i]['description'];
            $album_list[$i]['description_nohtml'] = texturize(strip_tags($album_list[$i]['description']));
            $album_list[$i]['description'] = autop(texturize($album_list[$i]['description']));
            $album_list[$i]['date_edited'] = date($gallery_date_format,  strtotime($album_list[$i]['date_edited']));
            $album_list[$i]['date_created'] = date($gallery_date_format,  strtotime($album_list[$i]['date_created']));

            // get cover_image by ID if not set
            if ( '' == $album_list[$i]['filename'] ) {
                $sql = " SELECT MIN(ID) FROM $table_photos "
                        ." WHERE album_id='{$album_list[$i]['ID']}' "
                        ." ORDER BY sort_order ASC ";
                $min_id = $db->get_var($sql);

                $sql = " SELECT u.filename "
                        ." FROM $table_photos p "
                        ." LEFT JOIN $table_uploads u ON p.upload_id=u.ID "
                        ." WHERE p.ID='$min_id' ";
                $album_list[$i]['filename'] = $db->get_var($sql);
            }

            $album_list[$i]['cover_image_thumbnail'] = $gallery_url.$path_photos.$thumbnail_prefix.$album_list[$i]['filename'];

            // create thumbnail if not present
            if (!file_exists($path_photos.$thumbnail_prefix.$album_list[$i]['filename'])) {
                auto_thumbnail($album_list[$i]['filename']);
            }

            $album_list[$i]['cover_image'] = $gallery_url.$path_photos.$album_list[$i]['filename'];
            $album_list[$i]['photo_count'] = $db->get_var(" SELECT COUNT(*) FROM $table_photos WHERE album_id='".$album_list[$i]['ID']."' AND visible='Y' ");

            $album_list[$i]['sanitized_name'] = $album_list[$i]['slug'];  // for backward-compatibilty

            if ($use_mod_rewrite) {
                $album_list[$i]['link'] = $gallery_url.$album_list[$i]['slug'].'/';
            } else {
                $album_list[$i]['link'] = $gallery_url.'?a='.$album_list[$i]['slug'];
            }

            $album_list[$i]['id'] = $album_list[$i]['ID'];

            $i++;
        }
    }


    // show variable info
    //ipap_debug($album_list);

    return $album_list;
}






/* ==========================================
    template function
    $internal_use = used in get_current_photo()
 ========================================== */
function __08_get_thumbnail_list($album_slug, $internal_use = false) //sql
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $table_albums, $table_photos, $table_uploads, $thumbnail_prefix, $path_photos, $url_zeroise, $truncate_length;

    $sql = " SELECT u.filename, u.width, u.height, u.date_uploaded, p.ID, p.title, p.caption, p.date_taken, p.date_edited, p.date_created "
            ." FROM $table_photos p "
            ." LEFT JOIN $table_uploads u ON p.upload_id=u.ID "
            ." LEFT JOIN $table_albums a ON p.album_id=a.ID "
            ." WHERE a.slug='$album_slug' "
            ." ORDER BY p.sort_order ASC ";
    $pp = $db->get_results($sql);

    // show variable info
    //ipap_debug($pp);


    if ($pp) {
        $i = 0;
        foreach ($pp as $p) {
            $photos[$i] = get_object_vars($p);

            $photos[$i]['filename'] = $photos[$i]['filename'];
            $photos[$i]['thumbnail'] = $photos[$i]['thumbnail'];
            $photos[$i]['width'] = $photos[$i]['width'];
            $photos[$i]['height'] = $photos[$i]['height'];
            $photos[$i]['date_uploaded'] = $photos[$i]['date_uploaded'];
            $photos[$i]['image'] = $gallery_url.$path_photos.$thumbnail_prefix.$photos[$i]['filename'];

            // create thumbnail if not present
            if (!file_exists($gallery_url.$path_photos.$thumbnail_prefix.$photos[$i]['filename'])) {
                auto_thumbnail($photos[$i]['filename']);
            }

            if ($use_mod_rewrite) {
                $photos[$i]['link'] = $gallery_url.$album_slug.'/'.zeroise($photos[$i]['ID'], $url_zeroise).'/';
            } else {
                $photos[$i]['link'] = $gallery_url.'?a='.$album_slug.'&amp;i='.$photos[$i]['ID'];
            }

            $photos[$i]['title_raw'] = $photos[$i]['title'];
            $photos[$i]['title_nohtml'] = texturize(strip_tags($photos[$i]['title']));
            $photos[$i]['title'] = texturize($photos[$i]['title']);
            $photos[$i]['caption_excerpt_nohtml'] = truncate(texturize(strip_tags($photos[$i]['caption'])), $truncate_length);
            $photos[$i]['caption_raw'] = $photos[$i]['caption'];
            $photos[$i]['caption_nohtml'] = texturize(strip_tags($photos[$i]['caption']));
            $photos[$i]['caption'] = autop(texturize($photos[$i]['caption']));
            $photos[$i]['date_taken'] = date($gallery_date_format,  strtotime($photos[$i]['date_taken']));
            $photos[$i]['date_edited'] = date($gallery_date_format,  strtotime($photos[$i]['date_edited']));
            $photos[$i]['date_created'] = date($gallery_date_format,  strtotime($photos[$i]['date_created']));

            $photos[$i]['id'] = $photos[$i]['ID'];

//            if (!$internal_use) {
//                // unset unused tags
//                unset($photos[$i]['visible']);
//                unset($photos[$i]['sort_order']);
//                unset($photos[$i]['upload_id']);
//                unset($photos[$i]['album_id']);
//                unset($photos[$i]['filename']);
//                unset($photos[$i]['date_uploaded']);
//                unset($photos[$i]['thumbnail']);
//                unset($photos[$i]['width']);
//                unset($photos[$i]['height']);
//            }
            $i++;
        }
    }

    return $photos;
}











function __08_get_current_photo($a, $i)
{
    global $db, $gallery_url, $path_photos, $table_photos, $table_albums;

    $current_photo = array();

    $photos = __08_get_thumbnail_list($a, 1);

    // show variable info
    //ipap_debug($photos);

/* 
    if ($img_id < 1) {
        $sql = " SELECT MIN(p.ID) "
                ." FROM $table_albums a "
                ." LEFT JOIN $table_photos p ON a.ID=p.album_id "
                ." WHERE a.slug='$album_slug' "
                ." GROUP BY p.ID "
                ." ORDER BY p.sort_order ASC ";
        $img_id = $db->get_var($sql);
    // show variable info
    //ipap_debug($img_id);
    }

 */


    if ($i < 1) {
        $sql = " SELECT MIN(p.ID) "
                ." FROM $table_albums a "
                ." LEFT JOIN $table_photos p ON a.ID=p.album_id "
                ." WHERE a.slug='$a' "
                ." GROUP BY p.ID "
                ." ORDER BY p.sort_order ASC ";
        $img_id = $db->get_var($sql);
    } else {
        $img_id = $i;
    }

    // show variable info
    //ipap_debug($img_id);




    $found = 0;
    for ($i=0; $i < count($photos); $i++) {
        if ($photos[$i]['id'] == $img_id) {
            $found = 1;

            $current_photo = $photos[$i];

    // show variable info
    //ipap_debug($photos[$i]);


            if (isset($photos[$i+1])) {
                $current_photo['next_link'] = $photos[$i+1]['link'];
                $current_photo['next_image_thumbnail'] = $photos[$i+1]['image'];
                $current_photo['next_title_raw'] = $photos[$i+1]['title_raw'];
                $current_photo['next_title_nohtml'] = $photos[$i+1]['title_nohtml'];
                $current_photo['next_title'] = $photos[$i+1]['title'];
                $current_photo['next_caption_excerpt_nohtml'] = $photos[$i+1]['caption_excerpt_nohtml'];
                $current_photo['next_caption_raw'] = $photos[$i+1]['caption_raw'];
                $current_photo['next_caption_nohtml'] = $photos[$i+1]['caption_nohtml'];
                $current_photo['next_caption'] = $photos[$i+1]['caption'];
            }
            if (isset($photos[$i-1])) {
                $current_photo['prev_link'] = $photos[$i-1]['link'];
                $current_photo['prev_image_thumbnail'] = $photos[$i-1]['image'];
                $current_photo['prev_title_raw'] = $photos[$i-1]['title_raw'];
                $current_photo['prev_title_nohtml'] = $photos[$i-1]['title_nohtml'];
                $current_photo['prev_title'] = $photos[$i-1]['title'];
                $current_photo['prev_caption_excerpt_nohtml'] = $photos[$i-1]['caption_excerpt_nohtml'];
                $current_photo['prev_caption_raw'] = $photos[$i-1]['caption_raw'];
                $current_photo['prev_caption_nohtml'] = $photos[$i-1]['caption_nohtml'];
                $current_photo['prev_caption'] = $photos[$i-1]['caption'];
            }



            $current_photo['filesize_kb'] = round(filesize($path_photos.$photos[$i]['filename'])/1024, 2);
            $current_photo['image'] = $gallery_url.$path_photos.$photos[$i]['filename'];
            $current_photo['permalink'] = $photos[$i]['link'];



            // remove unused tags
            //unset($current_photo['id']); added again for CSS unique ID
            //unset($current_photo['upload_id']);
            //unset($current_photo['album_id']);
            //unset($current_photo['sort_order']);
            unset($current_photo['filename']);
            unset($current_photo['thumbnail']);
            unset($current_photo['date_uploaded']);
            //unset($current_photo['visible']);
            //unset($current_photo['link']);


            break;
        }
    }
    // show variable info
    //ipap_debug($current_photo);

    if (!$found) {
        return 0;
    } else {
        return $current_photo;
    }
}










/* ==========================================
    template function
 ========================================== */
function __08_get_label_list() //sql
{
    global $db, $use_mod_rewrite, $gallery_url, $table_labels, $truncate_length;

/*     $db->open($path_db.$db_labels, 0);
    $label_list = $db->get_all();
    $db->close();

    $label_list = $db->order_by($label_list, 'sort_order', 'ASC');
    $label_list = show_visible($label_list);
 */

    $sql = " SELECT * FROM $table_labels "
            ." WHERE visible='Y' "
            ." ORDER BY sort_order ASC ";
    $labels = $db->get_results($sql);



    /* for ($i=0; $i < count($label_list); $i++) { */
    $i = 0;
    foreach ($labels as $label) {

        $label_list[$i] = get_object_vars($label);

        $label_list[$i]['name_raw'] = $label_list[$i]['label'];
        $label_list[$i]['name_nohtml'] = texturize(strip_tags($label_list[$i]['title']));
        $label_list[$i]['name'] = texturize($label_list[$i]['label']);
        $label_list[$i]['description_excerpt_nohtml'] = truncate(texturize(strip_tags($label_list[$i]['description'])), $truncate_length);
        $label_list[$i]['description_raw'] = $label_list[$i]['description'];
        $label_list[$i]['description_nohtml'] = texturize(strip_tags($label_list[$i]['description']));
        $label_list[$i]['description'] = autop(texturize($label_list[$i]['description']));


        if ($use_mod_rewrite) {
            $label_list[$i]['link'] = $gallery_url.'labels/'.$label_list[$i]['slug'].'/';
        } else {
            $label_list[$i]['link'] = $gallery_url.'?l='.$label_list[$i]['slug'];
        }

        // unset unused tags
        //unset($album_list[$i]['id']); added for unique CSS ID
        $i++;
    }

    // show variable info
    //ipap_debug($label_list);

    return $label_list;
}


















function __08_get_album_info($album_slug)
{
  /*   global $db, $f, $use_mod_rewrite, $gallery_url, $gallery_date_format, $db_albums, $db_photos, $db_uploads, $path_db; */

    global $db, $f, $use_mod_rewrite, $gallery_url, $gallery_date_format, $table_albums, $table_photos, $truncate_length;

/*
    $db->open($path_db.$db_albums, 0);
    $album = $db->select('slug', $album_slug);
    $db->close();
 */

    $sql = " SELECT * "
            ." FROM $table_albums "
            ." WHERE slug='$album_slug' ";
    $aa = $db->get_row($sql);

    $album[0] = get_object_vars($aa);

    $album[0]['title_raw'] = $album[0]['title'];
    $album[0]['title_nohtml'] = texturize(strip_tags($album[0]['title']));
    $album[0]['title'] = texturize($album[0]['title']);
    $album[0]['description_excerpt_nohtml'] = truncate(texturize(strip_tags($album[0]['description'])), $truncate_length);
    $album[0]['description_raw'] = $album[0]['description'];
    $album[0]['description_nohtml'] = texturize(strip_tags($album[0]['description']));
    $album[0]['description'] = autop(texturize($album[0]['description']));
    $album[0]['date_edited'] = date($gallery_date_format,  strtotime($album[0]['date_edited']));
    $album[0]['date_created'] = date($gallery_date_format,  strtotime($album[0]['date_created']));
  //  $album[0]['cover_image_thumbnail'] = get_cover_image($album_slug);
  //  $album[0]['cover_image'] = get_cover_image($album_slug, 0);
  //  $album[0]['photo_count'] = count_photos_for_album($album[0]['id']);
    $album[0]['photo_count'] = $db->get_var(" SELECT COUNT(*) FROM $table_photos WHERE album_id='".$album[0]['ID']."' AND visible='Y' ");
    $album[0]['sanitized_name'] = $album[0]['slug']; // for backward-compatibilty

    if ($use_mod_rewrite) {
        $album[0]['link'] = $gallery_url.$album[0]['slug'].'/';
    } else {
        $album[0]['link'] = $gallery_url.'?a='.$album[0]['slug'];
    }

    $album[0]['permalink'] = $album[0]['link'];
    // remove unused keys
    //unset($album[0]['id']); add for CSS ID
    unset($album[0]['sort_order']);
    unset($album[0]['visible']);

    // show variable info
    //ipap_debug($album[0]);


    return $album[0];
}






















//* MISC FUNCTIONS ---------------------------------------------------------


/*
This function sets the edit_time for an album.
*/
function touch_album($album_id)
/* function set_edit_time($album_id) */
{
    global $db, $server_time_offset, $table_albums; //$db_albums, $db_photos, $db_uploads, $path_db;

//    $db->open('../'.$path_db.$db_albums, 1);
//    $update['date_edited'] = date('Y-m-d H:i:s', time() + (3600 * $server_time_offset));
//    $db->update('id', $album_id, $update);
//    $db->close();

    $updated = date('Y-m-d H:i:s', time() + (3600 * $server_time_offset));
    $sql = " UPDATE $table_albums SET "
            ." date_edited='$updated' "
            ." WHERE ID='$album_id' ";
    $db->query($sql);
    if ($db->rows_affected > 0) {
        return true;
    }
}




/*
This function sets the edit_time for a photo.
*/
function touch_photo($photo_id)
{
    global $db, $server_time_offset, $table_photos;

    $updated = date('Y-m-d H:i:s', time() + (3600 * $server_time_offset));
    $sql = " UPDATE $table_photos SET "
            ." date_edited='$updated' "
            ." WHERE ID='$photo_id' ";
    $db->query($sql);

    if ($db->rows_affected > 0) {
        return true;
    }
}


// taken from wordpress
function format_to_edit($content) {
    $content = htmlspecialchars($content);
    return $content;
}

// taken from wordpress
function format_to_post($content) {
    global $db;
    $content = $db->escape($content);
    return $content;
}







/*
This function is a little like the opposite of
get_object_vars()
*/
function array_to_object_vars($old_array)
{
    $i = 0;
    while ($i < count($old_array)) {
        $k = array_keys($old_array[$i]);
        $v = array_values($old_array[$i]);

        $j = 0;
        while ($j < count($k)) {
            $new_array[$i]->$k[$j] = $v[$j];
            $j++;
        }

        $i++;
    }
    // show variable info
    //ipap_debug($new_array);

    return $new_array;
}






function apply_filters($filter_name, $filtered)
{
    global $filter;
    if (is_array($filter[$filter_name])/*  && count($filter[$filter_name]) > 0 */) {
        foreach ($filter[$filter_name] as $func) {
            if (function_exists($func)) {
                $filtered = call_user_func($func, $filtered);
            }
        }
    }/*  else {
        return $filtered;
    } */

    return $filtered;
}






function microtime_diff($a, $b, $precision = 3)
{
     list($a_micro, $a_int)=explode(' ',$a);
     list($b_micro, $b_int)=explode(' ',$b);
     if ($a_int>$b_int) {
        $val = ($a_int-$b_int)+($a_micro-$b_micro);
     } elseif ($a_int==$b_int) {
        if ($a_micro>$b_micro) {
           $val = ($a_int-$b_int)+($a_micro-$b_micro);
        } elseif ($a_micro<$b_micro) {
           $val = ($b_int-$a_int)+($b_micro-$a_micro);
        } else {
           $val = 0;
        }
     } else { // $a_int<$b_int
        $val = ($b_int-$a_int)+($b_micro-$a_micro);
     }
    return round($val, $precision);
}



function rnum()
{
    return rand(0,999);
}





function check_file_type($img_path)
{
    global $allowed_img_type;

    $info = getimagesize($img_path);
    if ( in_array($info['2'], $allowed_img_type) ) {
        return true;
    } else {
        return false;
    }
}






function get_settings()
{
    global $gallery_url, $path_templates, $template_path;

    $settings->template_path = $gallery_url.$path_templates.$template_path.'/';



    return $settings;
}



//function get_config()
//{
//    global $path_templates, $template_path;
//
//    $_c->incl_template_path = $path_templates.$template_path.'/';
//
//
//
//    return $_c;
//}




function ipap_debug($variable)
{
    echo "<pre style=\"font:10px 'bitstream vera sans mono';color:#0f0;background:#000;text-align:left;padding:10px;\">\n";
    echo 'Count: '.count($variable)."\n";
    ob_start();
    print_r($variable);
    $str = ob_get_contents();
    ob_end_clean();
    $str = htmlspecialchars($str);
    $str = str_replace('[', '<span style="color:#ff0;">[', $str);
    $str = str_replace('] =&gt;', ']</span> =&gt;', $str);
    $str = wordwrap($str, 96);
    echo $str;
    echo "</pre>\n";
}









// in: $path path/to/files
// out: array of filenames in the given directory
function getFiles($path) // TODO
{
    $_arr = array(); // the file listing array
    $handle = @opendir($path);
    if (!$handle) {
        exit('The path <strong>'.$path.'</strong> is invalid.');
    }
    while ($file = readdir($handle)) {
        if($file != '.' && $file != '..') {
            $_arr[count($_arr)] = $file;
        }
    }
    closedir($handle);
    for ($i=0; $i < count($_arr); $i++) {
        $_arr[$i] = $path.$_arr[$i];
    }
    rsort($_arr, SORT_STRING);
    return ($_arr);
}












// taken from wordpress
function zeroise($number,$threshold) { // function to add leading zeros when necessary
    return sprintf('%0'.$threshold.'s', $number);
}











//*  FORMATTING  -----------------------------------------------------------

// taken from wordpress
function texturize($text)
{
    $output = '';
    // Capture tags and everything inside them
    $textarr = preg_split("/(<.*>)/Us", $text, -1, PREG_SPLIT_DELIM_CAPTURE);
    $stop = count($textarr); $next = true; // loop stuff
    for ($i = 0; $i < $stop; $i++) {
        $curl = $textarr[$i];

        if (isset($curl{0}) && '<' != $curl{0} && $next) { // If it's not a tag
            $curl = str_replace('---', '&#8212;', $curl);
            $curl = preg_replace('/(\s)--(\s)/', '$1&#8212;$2', $curl);
            $curl = str_replace('--', '&#8211;', $curl);
            $curl = str_replace('...', '&#8230;', $curl);
            $curl = str_replace('``', '&#8220;', $curl);

            // This is a hack, look at this more later. It works pretty well though.
            $cockney = array("'tain't","'twere","'twas","'tis","'twill","'til","'bout","'nuff","'round");
            $cockneyreplace = array("&#8217;tain&#8217;t","&#8217;twere","&#8217;twas","&#8217;tis","&#8217;twill","&#8217;til","&#8217;bout","&#8217;nuff","&#8217;round");
            $curl = str_replace($cockney, $cockneyreplace, $curl);

            $curl = preg_replace("/'s/", '&#8217;s', $curl);
            $curl = preg_replace("/'(\d\d(?:&#8217;|')?s)/", "&#8217;$1", $curl);
            $curl = preg_replace('/(\s|\A|")\'/', '$1&#8216;', $curl);
            $curl = preg_replace('/(\d+)"/', '$1&#8243;', $curl);
            $curl = preg_replace("/(\d+)'/", '$1&#8242;', $curl);
            $curl = preg_replace("/(\S)'([^'\s])/", "$1&#8217;$2", $curl);
            $curl = preg_replace('/(\s|\A)"(?!\s)/', '$1&#8220;$2', $curl);
            $curl = preg_replace('/"(\s|\S|\Z)/', '&#8221;$1', $curl);
            $curl = preg_replace("/'([\s.]|\Z)/", '&#8217;$1', $curl);
            $curl = preg_replace("/ \(tm\)/i", ' &#8482;', $curl);
            $curl = str_replace("''", '&#8221;', $curl);

            $curl = preg_replace('/(d+)x(\d+)/', "$1&#215;$2", $curl);

        } elseif (strstr($curl, '<code') || strstr($curl, '<pre') || strstr($curl, '<kbd' || strstr($curl, '<style') || strstr($curl, '<script'))) {
            // strstr is fast
            $next = false;
        } else {
            $next = true;
        }
        $curl = preg_replace('/&([^#])(?![a-z12]{1,8};)/', '&#038;$1', $curl);
        $output .= $curl;
    }
    return $output;
}








// taken from wordpress
function autop($pee, $br = 1)
{
    $pee = $pee . "\n"; // just to make things a little easier, pad the end
    $pee = preg_replace('|<br />\s*<br />|', "\n\n", $pee);
    // Space things out a little
    $pee = preg_replace('!(<(?:table|thead|tfoot|caption|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|math|p|h[1-6])[^>]*>)!', "\n$1", $pee);
    $pee = preg_replace('!(</(?:table|thead|tfoot|caption|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|math|p|h[1-6])>)!', "$1\n", $pee);
    $pee = str_replace(array("\r\n", "\r"), "\n", $pee); // cross-platform newlines
    $pee = preg_replace("/\n\n+/", "\n\n", $pee); // take care of duplicates
    $pee = preg_replace('/\n?(.+?)(?:\n\s*\n|\z)/s', "\t<p>$1</p>\n", $pee); // make paragraphs, including one at the end
    $pee = preg_replace('|<p>\s*?</p>|', '', $pee); // under certain strange conditions it could create a P of entirely whitespace
    $pee = preg_replace('!<p>\s*(</?(?:table|thead|tfoot|caption|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|hr|pre|select|form|blockquote|math|p|h[1-6])[^>]*>)\s*</p>!', "$1", $pee); // don't pee all over a tag
    $pee = preg_replace("|<p>(<li.+?)</p>|", "$1", $pee); // problem with nested lists
    $pee = preg_replace('|<p><blockquote([^>]*)>|i', "<blockquote$1><p>", $pee);
    $pee = str_replace('</blockquote></p>', '</p></blockquote>', $pee);
    $pee = preg_replace('!<p>\s*(</?(?:table|thead|tfoot|caption|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|hr|pre|select|form|blockquote|math|p|h[1-6])[^>]*>)!', "$1", $pee);
    $pee = preg_replace('!(</?(?:table|thead|tfoot|caption|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|math|p|h[1-6])[^>]*>)\s*</p>!', "$1", $pee);
    if ($br) $pee = preg_replace('|(?<!<br />)\s*\n|', "<br />\n", $pee); // optionally make line breaks
    $pee = preg_replace('!(</?(?:table|thead|tfoot|caption|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|math|p|h[1-6])[^>]*>)\s*<br />!', "$1", $pee);
    $pee = preg_replace('!<br />(\s*</?(?:p|li|div|dl|dd|dt|th|pre|td|ul|ol)>)!', '$1', $pee);
    $pee = preg_replace('!(<pre.*?>)(.*?)</pre>!ise', " stripslashes('$1') .  clean_pre('$2')  . '</pre>' ", $pee);

    return $pee;
}







// taken from smarty
function truncate($string, $length = 80, $etc = '&#171;', $break_words = false)
{
    if ($length == 0)
        return '';

    if (strlen($string) > $length) {
        $length -= strlen($etc);
        if (!$break_words)
            $string = preg_replace('/\s+?(\S+)?$/', '', substr($string, 0, $length+1));

        return substr($string, 0, $length).$etc;
    } else
        return $string;
}







function reformat_exif_date($exif_date)
{
    $exif_date = trim($exif_date);
    $exif_date = substr($exif_date, 0, 4).'-'.substr($exif_date, 5, 2).'-'.substr($exif_date, 8, 2).' '.substr($exif_date, 11, 2).':'.substr($exif_date, 14, 2).':'.substr($exif_date, 17, 2);
    return $exif_date;
}








// taken from wordpress
function sanitize_title($title)
{
    $title = strtolower($title);
    $title = preg_replace('/&.+?;/', '', $title); // kill entities
    $title = preg_replace('/[^%a-z0-9 _-]/', '', $title);
    $title = preg_replace('/\s+/', '-', $title);
    $title = preg_replace('|-+|', '-', $title);
    $title = trim($title, '-');

    return $title;
}









//*  TEMPLATE FORMATTING  --------------------------------------------------


function alt($text)
{
    return texturize(strip_tags($text));
}


function short_alt($text)
{
    global $truncate_length;
    return truncate(texturize(strip_tags($text)), $truncate_length);

}








?>