<?php
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");                   // Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");      // always modified
header("Cache-Control: no-store, no-cache, must-revalidate");       // HTTP/1.1
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");                                         // HTTP/1.0


require_once '../ipap-config.php';
require_once '../'.$path_lib.'functions.php';
require_once '../'.$path_lib.'ez_sql.php';
include_once '../'.$path_admin.'admin-includes.php';


// magic_quotes thingie from wordpress
function add_magic_quotes($array) {
foreach ($array as $k => $v) {
    if (is_array($v)) {
        $array[$k] = add_magic_quotes($v);
    } else {
        $array[$k] = addslashes($v);
    }
}
return $array;
}

if (!get_magic_quotes_gpc()) {
$_GET    = add_magic_quotes($_GET);
$_POST   = add_magic_quotes($_POST);
$_COOKIE = add_magic_quotes($_COOKIE);
}





$start = microtime();
session_start();
$self = 'index.php';
$now_timestamp = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));



if ($_SESSION['username'] != $admin_username  && $_SESSION['password'] != md5($admin_password.$admin_username.$admin_random_key)) {
    header('Location:'.$gallery_url.'login.php');
    exit('ayaw.');
}



echo $html_header;
//*  end HEADER stuff  -----------------------------------------------------












switch ($_REQUEST['op']) {






    case 'clear-cache' : { //*
    // 2005-06-19 15:23:13

        echo '<h2>Publish</h2>';

        $_arr = array(); // the file listing array
        $handle = @opendir('../'.$path_temp);
        if (!$handle) {
            exit('The path <strong>'.$path.'</strong> is invalid.');
        }
        while ($file = readdir($handle)) {
            if($file != '.' && $file != '..') {
                $_arr[count($_arr)] = $file;
            }
        }
        closedir($handle);
        for ($i=0; $i < count($_arr); $i++) {
            $_arr[$i] = $path.$_arr[$i];
        }
        rsort($_arr, SORT_STRING);
        //print_r($_arr);

        foreach ($_arr as $file) {
            if ( !stristr($file, 'index.php') ) {
                unlink('../'.$path_temp.$file);
            }
        }
        echo '<p>The cache has been cleared.</p>';

        echo '<p>This app doesn&#8217;t actually &#8220;publish&#8221; files,
        it instead clears the cache of files produced as pages are viewed.
        If you change any album or photo details, or update a template, you
        must publish to reflect the changes.</p>';

        break;
    }






    case 'delete-album' : { //*
    // 2005-05-01 04:42:00

        $album_id = intval(strip_tags($_GET['album_id']));

        echo '<h2>Delete Album</h2>';

        if (isset($_GET['confirm'])) {

            $album_title = $db->get_var("SELECT title FROM $table_albums WHERE ID='$album_id'");


            $sql = "DELETE FROM $table_labelsrel WHERE album_id='$album_id' ";
            $db->query($sql);
            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">Instances in labels deleted.</p>';
            }



            $sql = "DELETE FROM $table_photos WHERE album_id='$album_id' ";
            $db->query($sql);
            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">Instances in photos deleted.</p>';
            }



            $sql = "DELETE FROM $table_albums WHERE ID='$album_id' ";
            $db->query($sql);
            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">The album <strong>'.$album_title.'</strong> has been deleted.</p>';
            }

            echo '<ol>';
            echo '<li><a href="'.$self.'">Return to albums</a></li>';
            echo '</ol>';


        } else { // ask for confirmation


            $album_title = $db->get_var("SELECT title FROM $table_albums WHERE ID='$album_id'");

            echo '<p>Are you sure you want to delete the album <strong>'.$album_title.'</strong>?</p>';

            echo '<p>Deleting an album also deletes all instances of photos
                    within the album, but these photos are still kept
                    in the <code>uploads</code> database.</p>';



            echo '<ol>';
            echo '<li><a href="'.$self.'?op=delete-album&amp;confirm=1&amp;album_id='.$album_id.'">Yes, delete the album</a></li>';
            echo '<li><a href="'.$self.'">Return to albums</a></li>';
            echo '</ol>';


        }
        break;
    }







    case 'reset-cover-photo' : { //*
    // 2005-05-01 05:02:51
    //sql


        $album_id = intval(strip_tags($_GET['album_id']));
        $album_title = $db->get_var("SELECT title FROM $table_albums WHERE ID='$album_id'");

        echo '<h2>Reset cover photo for album '.$album_title.'</h2>';

        $sql = " UPDATE $table_albums SET "
                ." cover_image='0' "
                ." WHERE ID=$album_id ";
        $db->query($sql);
        if ($db->rows_affected > 0) {
            echo '<p id="p'.rnum().'" class="fade notice">Cover photo for the album <strong>'.$album_title.'</strong> has been reset.</p>';
        }

        // modify last edit time of album
        touch_album($album_id);


        echo '<ol>';
        echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Return to its album</a></li>';
        echo '<li><a href="'.$self.'">Return to albums</a></li>';
        echo '</ol>';


        break;
    }










    case 'edit-album-sort' : { //*
    // 2005-05-01 05:08:25
    //sql

        echo '<h2>Albums</h2>';

        // load all albums
        $sql = "SELECT ID, title FROM $table_albums ORDER BY sort_order DESC";
        $curr_id = $db->get_results($sql);

        foreach ($curr_id as $value) {
            unset($new_sort_order, $new_visible, $new_in_frontpage);

            isset($_POST['sort_'.$value->ID]) ? $new_sort_order = format_to_post($_POST['sort_'.$value->ID]) : $new_sort_order = '00';
            isset($_POST['visible_'.$value->ID]) ? $new_visible = 'Y' : $new_visible = 'N';
            isset($_POST['infrontpage_'.$value->ID]) ? $new_in_frontpage = 'Y' : $new_in_frontpage = 'N';


            $sql = " UPDATE $table_albums SET "
                    ." sort_order='$new_sort_order', "
                    ." visible='$new_visible', "
                    ." in_frontpage='$new_in_frontpage' "
                    ." WHERE ID=$value->ID ";
            $db->query($sql);

            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">Updated sort order and visibility info for album '.$value->title.'.</p>';
            }
        }

                echo '<ol>';
                echo '<li><a href="'.$self.'">Return to albums</a></li>';
                echo '</ol>';

        break;
    }









    case 'make-album': { //* 2005-05-21 18:55:27
        /* check for album named "label" or "labels" or "tags" */
        $new_title = $_POST['album'];
        $new_slug = sanitize_title($new_title);

        $c2 = $db->get_var("SELECT slug FROM $table_albums WHERE slug='".$new_slug."'");

        echo '<h2>Add new album</h2>';
        if ( isset($_REQUEST['makecheck']) ) {

            if ( strlen($new_title) == 0 || strlen($new_slug) == 0  ) {

                echo '<p id="p'.rnum().'" class="fade notice">The length of the album&#8217;s <strong>title</strong> must be at least 1 character.</p>';

                echo '<ol>';
                echo '<li><a href="'.$self.'">Return to albums</a></li>';
                echo '</ol>';

            } elseif ( $c2 && strlen($new_title) > 0 && strlen($new_slug) > 0 ) {

                echo '<p id="p'.rnum().'" class="fade notice">An album with the same <strong>slug</strong> already exists.</p>';

                echo '<ol>';
                echo '<li><a href="'.$self.'">Return to albums</a></li>';
                echo '</ol>';

            } else {

                $sql = "SELECT MAX(sort_order) FROM $table_albums";
                $counter = intval($db->get_var($sql)) + 10;

                $new_title = format_to_post($new_title);
                $sql = "INSERT INTO $table_albums SET "
                        ."title='$new_title', "
                        ."slug='$new_slug', "
                        ."sort_order='$counter', "
                        ."visible='Y', "
                        ."in_frontpage='Y', "
                        ."description='', "
                        ."cover_image='', "
                        ."date_created='$now_timestamp', "
                        ."date_edited='$now_timestamp' ";
                $db->query($sql);
                if ($db->rows_affected > 0) {
                    echo '<p id="p'.rnum().'" class="fade notice">The album <strong>'.stripslashes($new_title).'</strong> has been created.</p>';
                }

                $sql = "SELECT ID, title FROM $table_albums WHERE slug='$new_slug'";
                $album = $db->get_row($sql);


                echo '<ol>';
                echo '<li><a href="'.$self.'?op=upload-to-album&amp;album_id='.$album->ID.'">upload photos to <strong>'.strip_tags($album->title).'</strong></a></li>';
                echo '<li><a href="'.$self.'">Return to albums</a></li>';
                echo '</ol>';
            }
        }
        break;
    }












    case 'upload-to-album': { //*
    // 2005-05-01 14:06:41
    //sql

        /*
            REQUIRES:
                $_POST['album_id']

            verifies $_POST['uploadcheck'] if posting files or pre-selecting
        */


        $album_id = intval(strip_tags($_POST['album_id']));
        $album_title = $db->get_var("SELECT title FROM $table_albums WHERE ID='$album_id'");


        if (!isset($_POST['uploadcheck'])) {

            echo '<h2>Upload to: '.$album_title.'</h2>';
            echo '<form name="form1" enctype="multipart/form-data" method="post" action="'.$self.'?op=upload-to-album"><input type="checkbox" name="doresize">Resize images to <input type="text" name="maxsize" size="5"> pixels<table>';
            for ($i=0; $i < $upload_file_limit; $i++) {
                echo '<tr><td><label for="uploadfile'.$i.'">Photo #'.($i+1).'</label></td><td><input name="uploadfile'.$i.'" type="file" size="50" id="uploadfile'.$i.'"></td></tr>';
            }

            echo '</table>';
            echo '<input name="album_id" type="hidden" value="'.$_REQUEST['album_id'].'" />';
            echo '<input name="uploadcheck" type="hidden" />
            <br /><br /><input type="submit" name="Submit" value="Upload photos" class="mysubmit" />
            </form>';



        } elseif (isset($_POST['uploadcheck'])) {

            echo '<h2>Upload to: '.$album_title.'</h2>';

            for ($x=0; $x < $upload_file_limit; $x++) {
            $copy = false;

                if (  isset($_FILES['uploadfile'. $x]['tmp_name'])  && check_file_type($_FILES['uploadfile'. $x]['tmp_name'])  ) {

                    $file_name = $_FILES['uploadfile'. $x]['name'];
                    // strip file_name of slashes

                    $file_name = stripslashes($file_name);
                    $file_name = str_replace("'","",$file_name);
                    $file_name = str_replace($thumbnail_prefix,"",$file_name);

                        if ( !file_exists('../'.$path_photos.$file_name) ) {
                            $copy = copy($_FILES['uploadfile'. $x]['tmp_name'], '../'.$path_photos.$file_name);

                            // check if successfully copied
                            if($copy) {
                                echo '<strong>'.$file_name.'</strong> has been uploaded sucessfully.<br />';

                                auto_thumbnail($file_name); // code from Joe Hughes <joe@retrovirus.com>, thanks Joe!
                                if (isset($_POST['doresize']) && isset($_POST['maxsize'])) {
                                    resize_image($file_name, intval($_POST['maxsize']));
                                }
                                $info = getimagesize('../'.$path_photos.$file_name);

                                // add to the uploads db
                                $sql = " INSERT INTO $table_uploads SET "
                                        ." filename='$file_name', "
                                        ." width='$info[0]', "
                                        ." height='$info[1]', "
                                        ." date_uploaded='$now_timestamp' ";
                                $db->query($sql);


                                // write to album
                                $sql = "SELECT MAX(sort_order) FROM $table_photos WHERE album_id='$album_id' ";
                                $new_sort_order = $db->get_var($sql) + 10;
                                $new_upload_id = $db->insert_id;
                                /* $new_album_id = stripslashes($_REQUEST['album_id']); */
                                $new_album_id = $album_id;
                                $new_title = substr($file_name, 0, strrpos($file_name, '.'));
                                $new_caption = '';
                                $new__visible = 'Y';
                                $new_date_created = $now_timestamp;
                                $new_date_edited = $now_timestamp;

                                require_once '../'.$path_lib.'class.exif.php';
                                $exif = new ipap_exif('../'.$path_photos.$file_name);
                                $exif->process_file();
                                if ( strlen($exif->get_exif_date()) > 0 ) {
                                    $new_date_taken = reformat_exif_date($exif->get_exif_date());
                                } else {
                                    $new_date_taken = date('Y-m-d H:i:s', filemtime('../'.$path_photos.$file_name) + (3600*$server_time_offset));
                                }

                                $sql = " INSERT INTO $table_photos SET "
                                        ." sort_order='$new_sort_order', "
                                        ." upload_id='$new_upload_id', "
                                        ." album_id='$new_album_id', "
                                        ." title='$new_title', "
                                        ." caption='$new_caption', "
                                        ." visible='$new__visible', "
                                        ." date_created='$new_date_created', "
                                        ." date_edited='$new_date_edited', "
                                        ." date_taken='$new_date_taken' ";
                                $db->query($sql);

                                if ($db->rows_affected > 0) {
                                    echo '<strong>'.$file_name.'</strong> has been added to the <strong>'.$album_title.'</strong> photo album.<br />';
                                }

                                // modify last edit time of album
                                touch_album($new_album_id);

                                unset($new_sort_order, $new_upload_id, $new_album_id, $new_title, $new_caption, $new__visible, $new_date_created, $new_date_edited, $new_date_taken,$new_photo_id);

                            } else {
                                echo '<strong>'.$file_name.'</strong> could not be uploaded!<br />';
                            }

                        } else {
                            echo 'Sorry, the file <strong>'.$_FILES['uploadfile'. $x]['name']. '</strong> already exists.<br />';
                        }


                } elseif ( strlen($_FILES['uploadfile'. $x]['name']) > 1 ) {
                    echo '<strong>'.$_FILES['uploadfile'. $x]['name']. '</strong> is not a valid file.<br />';
                }

            }

            echo '<ol>';
            echo '<li><a href="'.$self.'?op=upload-to-album&amp;album_id='.$album_id.'">Upload more to this album</a></li>';
            echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Edit this album&#8217;s details</a></li>';
            echo '<li><a href="'.$self.'">Return to albums</a></li>';
            echo '</ol>';


        }

        break;
    }

















    case 'edit-album': { //* 2005-05-21 18:56:05

        $album_id = intval(strip_tags($_REQUEST['album_id']));

        if (isset($_POST['save_info'])) {
            // requires $_REQUEST['album_id']
            // and other $_POST vars

            $sql = " SELECT title FROM $table_albums WHERE ID='$album_id' ";
            $album_title = $db->get_var($sql);

            echo '<h2>Editing photo album: '.$album_title.'</h2>';

            $new_title = format_to_post($_POST['album_title']);
            $new_description = format_to_post($_POST['album_description']);
            $new_date_created = format_to_post($_POST['album_date_created']);
            $new_date_edited = $now_timestamp;
            $new_sort_order = format_to_post($_POST['album_sort_order']);
            $new_cover_image = format_to_post($_POST['album_cover_image']);


            isset($_POST['album_visible']) ? $new_visible = 'Y' : $new_visible = 'N';
            isset($_POST['album_in_frontpage']) ? $new_in_frontpage = 'Y' : $new_in_frontpage = 'N';


            $sql = " UPDATE $table_albums SET "
                    ." title='$new_title', "
                    ." description='$new_description', "
                    ." date_created='$new_date_created', "
                    ." date_edited='$new_date_edited', "
                    ." sort_order='$new_sort_order', "
                    ." cover_image='$new_cover_image', "
                    ." visible='$new_visible', "
                    ." in_frontpage='$new_in_frontpage' "
                    ." WHERE ID='$album_id' ";
            $db->query($sql);

            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">The album <strong>'.stripslashes($new_title).'</strong> has been edited.</p>';
            }

            // modify last edit time of album
            touch_album($album_id);


            echo '<ol>';
            echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Continue editing this album</a></li>';
            echo '<li><a href="'.$self.'?op=upload-to-album&amp;album_id='.$album_id.'">Upload to this album</a></li>';
            echo '<li><a href="'.$self.'">Return to albums</a></li>';
            echo '</ol>';




        } else {



            // get the album's info
            $sql = "SELECT ID, title, description, date_created, sort_order, cover_image, visible, in_frontpage "
                    ." FROM $table_albums WHERE ID='$album_id'";
            $album = $db->get_row($sql);
            echo '<h2>Editing photo album: '.$album->title.'</h2>';



            // get photos for this album
            $sql = " SELECT p.ID, p.title, p.sort_order, p.visible, p.date_edited, p.upload_id, u.filename, u.width, u.height "
                    ." FROM $table_photos p LEFT JOIN $table_uploads u "
                    ." ON p.upload_id=u.ID "
                    ." WHERE p.album_id='$album_id' "
                    ." ORDER BY p.sort_order ASC ";
            $photos = $db->get_results($sql);


            $album->visible == 'Y' ? $checked = 'checked="checked"' : $checked = '';
            $album->in_frontpage == 'Y' ? $checked2 = 'checked="checked"' : $checked2 = '';

            ?>

            <p><a href="<?php echo $self; ?>?op=upload-to-album&amp;album_id=<?php echo $album->ID; ?>">Upload to this album</a> &#183; <a href="<?php echo $self; ?>?op=delete-album&amp;album_id=<?php echo $album->ID; ?>">delete this album</a> &#183; <a href="#" onclick="toggle('inline-help-2');return false;" title="Hide or show help (below).">Help?</a></p>

            <p id="inline-help-2" style="display:none;">Special characters in the <strong>title</strong> and <strong>description</strong>
            field are automatically converted to their markup equivalents. In addition, linebreaks
            in the description are automatically converted. A <strong>single linebreak for a new line</strong>, <strong>two
            linebreaks to start a new paragraph</strong>.
            </p>

            <form enctype="multipart/form-data" method="post" action="<?php echo $self; ?>?op=edit-album">
            <input type="hidden" name="album_id" value="<?php echo $album->ID; ?>" />
            <input type="hidden" name="save_info" />

            <p><label for="album_title">Album Title:</label><br /><input type="text" id="album_title" name="album_title" size="50" value="<?php echo format_to_edit($album->title); ?>" /></p>


            <p><label for="album_description">Album Description:</label><br /><textarea id="album_description" name="album_description" rows="10" cols="50"><?php echo format_to_edit($album->description); ?></textarea>
            <!-- dunstan's increase/decrease textarea. thanks, mate! -->
            <script type="text/javascript">
            <!--
            document.write('<br />');
            document.write('<small>(Textarea: <span style="cursor: pointer;" onclick="document.getElementById(\'album_description\').rows += 5;" title="Click to enlarge the  textarea">Increase size</span> | <span style="cursor: pointer;" onclick="document.getElementById(\'album_description\').rows -= 5;" title="Click to decrease the textarea">Decrease size</span>)</small>');
            //-->
            </script>
            </p>

            <p><label for="album_date_created">Date Created/Cloned:</label><br /><input type="text" id="album_date_created" name="album_date_created" size="35" value="<?php echo format_to_edit($album->date_created); ?>" /></p>

            <p><label for="album_sort_order">Sort Order:</label><br /><input type="text" id="album_sort_order" name="album_sort_order" size="10" value="<?php echo format_to_edit($album->sort_order); ?>" /></p>

            <p><label for="album_cover_image">Cover Image ID:</label><br /><input type="text" id="album_cover_image" name="album_cover_image" size="10" value="<?php echo format_to_edit($album->cover_image); ?>" /></p>

            <p><label for="album_visible">Visible?</label><br /><input type="checkbox" id="album_visible" name="album_visible" <?php echo $checked; ?> /></p>

            <p><label for="album_in_frontpage">Show in frontpage?</label><br /><input type="checkbox" id="album_in_frontpage" name="album_in_frontpage" <?php echo $checked2; ?> /></p>

            <input class="mysubmit" type="submit" name="Submit" value="Save changes" />
            </form>


            <?php



            if ($photos) {
                ?>



                <h2>Photos in this album</h2>


                <p>
                    <a href="#" onclick="toggleclass('th', 'toggle-sort-column');toggleclass('td', 'toggle-sort-column');return false;">Reorder photos</a> &#183;
                    <a href="#" onclick="toggleclass('th', 'toggle-visibility');toggleclass('td', 'toggle-visibility');return false;">Change visibility</a> &#183;
                    <a href="#" onclick="toggle('inline-help');return false;" title="Hide or show help (below).">Help?</a>
                </p>




                <ul id="inline-help" style="display:none;">
                    <li><strong>Sort order</strong>  &#8594; Display sequence of photo albums. Numerically sorted (lowest first).</li>
                    <li><strong>Visible?</strong>  &#8594; Uncheck this to hide a photo.</li>
                    <li><strong>Title</strong>  &#8594; Edit to change the photo&#8217;s title.</li>
                    <li><strong>Edit</strong>  &#8594; Edit the photo&#8217;s details.</li>
                    <li><strong>Cover</strong>  &#8594; Set this photo as the album&#8217;s cover (first photo displayed).</li>
                    <li><strong>thumbnail</strong>  &#8594; Replace this photo&#8217;s thumbnail.</li>
                    <li><strong>Clone</strong>  &#8594; Clone the photo to another photo album.</li>
                    <li><strong>Remove</strong>  &#8594; Remove photo from this album.</li>
                </ul>






                <form enctype="multipart/form-data" method="post" action="<?php echo $self; ?>?op=edit-photo-sort">
                <table width="100%">
                <tr>
                    <th class="toggle-sort-column" style="display:none;">Sort Order</th>
                    <th class="toggle-visibility" style="display:none;">Visible?</th>
                    <th>Photo</th>
                    <th>Details</th>
                </tr>


                <?php

                foreach ($photos as $photo) {

                    if (!file_exists('../'.$path_photos.$thumbnail_prefix.$photo->filename)) {
                        auto_thumbnail($photo->filename);
                    }
                    $img = '<img src="../'.$path_photos.$thumbnail_prefix.$photo->filename.'" />';
                    $full = '<br /><a href="../'.$path_photos.$photo->filename.'">view full photo</a>';


                    $photo->visible == 'Y' ? $checked = 'checked="checked"' : $checked = '';

                    ?>

                    <tr>
                        <td class="toggle-sort-column" style="display:none;"><input type="text" id="sort_<?php echo $photo->ID; ?>" name="sort_<?php echo $photo->ID; ?>" size="4" value="<?php echo $photo->sort_order; ?>" /></td>

                        <td class="toggle-visibility" style="display:none;"><input type="checkbox" id="visible_<?php echo $photo->ID; ?>" name="visible_<?php echo $photo->ID; ?>" <?php echo $checked; ?> /></td>


                        <td><?php echo $img.$full; ?></td>


                        <td>
                            <label for="title_<?php echo format_to_edit($photo->ID); ?>">Title:</label><br />
                            <input type="text" id="title_<?php echo $photo->ID; ?>" name="title_<?php echo $photo->ID; ?>" size="24" value="<?php echo format_to_edit($photo->title); ?>" />

                            <p class="actions">
                            <?php echo $photo->width; ?> x <?php echo $photo->height; ?> ( <?php echo round(filesize('../'.$path_photos.$photo->filename)/1024); ?> KB)<br />
                            Last changed : <?php echo date($gallery_date_format, strtotime($photo->date_edited)); ?><br />

                            <a href="<?php echo $self; ?>?op=edit-photo&amp;id=<?php echo $photo->ID; ?>&amp;album_id=<?php echo $album_id; ?>" title="Edit this photo&#8217;s details.">edit</a> &#183;
                            <a href="<?php echo $self; ?>?op=set-cover-photo&amp;id=<?php echo $photo->ID; ?>&amp;album_id=<?php echo $album_id; ?>" title="Set photo as this album&#8217;s cover.">cover</a> &#183;
                            <a href="<?php echo $self; ?>?op=reset-thumbnail&amp;upload_id=<?php echo $photo->upload_id; ?>&amp;album_id=<?php echo $album_id; ?>" title="Change this photo&#8217;s thumbnail.">thumbnail</a> &#183;
                            <a href="<?php echo $self; ?>?op=clone-photo&amp;photo_id=<?php echo $photo->ID; ?>&amp;album_id=<?php echo $album_id; ?>" title="Clone this photo to another album.">clone</a> &#183;
                            <a href="<?php echo $self; ?>?op=delete-photo&amp;id=<?php echo $photo->ID; ?>&amp;album_id=<?php echo $album_id; ?>" title="Remove photo from this album.">remove</a>
                            </td>
                            </p>

                        </td>
                    </tr>

                    <?php

                }


                echo '</table>';
                echo '<input type="hidden" name="album_id" value="'.$album_id.'" />';
                echo '<p><input class="mysubmit" type="submit" name="Submit" value="Save changes to sort,visibility, &amp; title" /></p>';
                echo '</form>';

            } else {
                ?>
                <h2>Photos in this album</h2>
                <p>No photos in this album yet.</p>
                <?php
            }
        }
        break;
    }












    case 'edit-photo-sort': { //*
    // 2005-05-01 14:39:04

        $album_id = intval(strip_tags($_POST['album_id']));

        $sql = " SELECT title FROM $table_albums WHERE ID='$album_id' ";
        $album_title = $db->get_var($sql);


        echo '<h2>Edit: '.$album_title.'</h2>';

        $sql = " SELECT ID, title FROM $table_photos "
                ." WHERE album_id='$album_id' ";
        $res = $db->get_results($sql);

        foreach ($res as $value) {
            unset($new_sort_order, $new_title, $new_visible);

            isset($_POST['sort_'.$value->ID]) ? $new_sort_order = format_to_post($_POST['sort_'.$value->ID]) : $new_sort_order = '00';
            isset($_POST['title_'.$value->ID]) ? $new_title = format_to_post($_POST['title_'.$value->ID]) : $new_title = '';
            isset($_POST['visible_'.$value->ID]) ? $new_visible = 'Y' : $new_visible = 'N';

            $sql = " UPDATE $table_photos SET "
                    ." sort_order='$new_sort_order', "
                    ." visible='$new_visible', "
                    ." title='$new_title' "
                    ." WHERE ID=$value->ID ";
            $db->query($sql);

            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">Saved new title, sort order and visibility info for photo <strong>'.$value->title.'</strong>.</p>';
            }

        }


        // modify last edit time of album
        touch_album($album_id);


        echo '<ol>';
        echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Continue editing this album</a></li>';
        echo '<li><a href="'.$self.'?op=upload-to-album&amp;album_id='.$album_id.'">Upload to this album</a></li>';
        echo '<li><a href="'.$self.'">Return to albums</a></li>';
        echo '</ol>';

        break;
    }







    case 'edit-photo': { //*
    // 2005-05-01 15:31:15

        $album_id = intval(strip_tags($_REQUEST['album_id']));
        $id = intval(strip_tags($_GET['id']));


        if (!isset($_POST['save'])) {

            $sql = " SELECT p.ID, p.title, p.caption, p.sort_order, p.visible, p.date_taken, p.date_created, p.upload_id, u.filename, u.width, u.height "
                    ." FROM $table_photos p LEFT JOIN $table_uploads u "
                    ." ON p.upload_id=u.ID "
                    ." WHERE p.ID='$id' ";
            $photo = $db->get_row($sql);


            if (!file_exists('../'.$path_photos.$thumbnail_prefix.$photo->filename)) {
                auto_thumbnail($photo->filename);
            }
            $img = '<img src="../'.$path_photos.$thumbnail_prefix.$photo->filename.'" />';
            $full = '<br /><a href="../'.$path_photos.$photo->filename.'">view full photo</a>';

            if (isset($_REQUEST['reextract'])) {
                require_once '../'.$path_lib.'class.exif.php';
                $exif = new ipap_exif('../'.$path_photos.$photo->filename);
                $exif->process_file();
                $photo->date_taken = reformat_exif_date($exif->get_exif_date());
            }


            $photo->visible == 'Y' ? $checked = 'checked="checked"' : $checked = '';


            ?>

            <h2>Editing: <?php echo $photo->title; ?></h2>

            <p>Special characters in the <strong>title</strong> and <strong>caption</strong>
            field are automatically converted to their markup equivalents. In addition, linebreaks
            in the caption are automatically converted. A <strong>single linebreak for a new line</strong>, <strong>two
            linebreaks to start a new paragraph</strong>.
            </p>



            <form enctype="multipart/form-data" method="post" action="<?php echo $self; ?>?op=edit-photo">
            <input type="hidden" name="photo_id" value="<?php echo $photo->ID; ?>" />
            <input type="hidden" name="album_id" value="<?php echo $album_id; ?>" />
            <input type="hidden" name="save" />
            <p style="float:left; margin:0 20px 350px 0"><?php echo $img.$full; ?></p>

            <p><label for="photo_title">Photo Title:</label><br /><input type="text" id="photo_title" name="photo_title" size="50" value="<?php echo format_to_edit($photo->title); ?>" /></p>

            <p><label for="photo_caption">Photo Caption:</label><br /><textarea id="photo_caption" name="photo_caption" rows="10" cols="50"><?php echo format_to_edit($photo->caption); ?></textarea></p>

            <p><label for="photo_date_taken">Date Taken:</label><br /><input type="text" id="photo_date_taken" name="photo_date_taken" size="35" value="<?php echo format_to_edit($photo->date_taken); ?>" /></p>

            <p><label for="photo_date_created">Date Created/Cloned:</label><br /><input type="text" id="photo_date_created" name="photo_date_created" size="35" value="<?php echo format_to_edit($photo->date_created); ?>" /></p>

            <p><label for="photo_sort_order">Sort Order:</label><br /><input type="text" id="photo_sort_order" name="photo_sort_order" size="10" value="<?php echo format_to_edit($photo->sort_order); ?>" /></p>

            <p><label for="photo_visible">Visible?</label><input type="checkbox" id="photo_visible" name="photo_visible" <?php echo $checked; ?> /></p>

            <p><input class="mysubmit" type="submit" name="Submit" value="Save changes" /></p>

            </form>


            <?php
            // not needed? 2005-05-29 (Sunday)
            if (strlen($photo->date_taken) < 2) { // re-extract exif date, maybe other things later
                echo '<form enctype="multipart/form-data" method="post">';
                echo '<input type="hidden" name="reextract" />';
                echo '<input class="mysubmit" type="submit" name="Submit" value="Re-extract exif date" />';
                echo '</form>';
            }

        } else {

            echo '<h2>Editing: '.stripslashes($_POST['photo_title']).'</h2>';

            $photo_id = format_to_post($_POST['photo_id']);

            $new_title = format_to_post($_POST['photo_title']);
            $new_caption = format_to_post($_POST['photo_caption']);
            $new_date_taken = format_to_post($_POST['photo_date_taken']);
            $new_date_created = format_to_post($_POST['photo_date_created']);
            $new_date_edited = $now_timestamp;
            $new_sort_order = format_to_post($_POST['photo_sort_order']);

            isset($_POST['photo_visible']) ? $new_visible = 'Y' : $new_visible = 'N';

            $sql = " UPDATE $table_photos SET "
                    ." title='$new_title', "
                    ." caption='$new_caption', "
                    ." date_taken='$new_date_taken', "
                    ." date_created='$new_date_created', "
                    ." date_edited='$new_date_edited', "
                    ." sort_order='$new_sort_order', "
                    ." visible='$new_visible' "
                    ." WHERE ID=$photo_id ";
            $db->query($sql);

            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">Saved new title, sort order and visibility info for photo <strong>'.$new_title.'</strong>.</p>';
            }

            // modify last edit time of album
            touch_album($album_id);


            echo '<ol>';
            echo '<li><a href="'.$_SERVER['HTTP_REFERER'].'">Edit the photo again</a></li>';
            echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Go back to its album</a></li>';
            echo '<li><a href="'.$self.'">Return to albums</a></li>';
            echo '</ol>';


        }

        break;
    }






    case 'set-cover-photo': { //*
    // 2004-04-30 00:45:37

        $album_id = intval(strip_tags($_GET['album_id']));
        $photo_id = intval(strip_tags($_GET['id']));

        $album_title = $db->get_var("SELECT title FROM $table_albums WHERE ID='$album_id'");

        echo '<h2>Set cover photo for album '.$album_title.'</h2>';

        $sql = " UPDATE $table_albums SET "
                ." cover_image='$photo_id' "
                ." WHERE ID=$album_id ";
        $db->query($sql);
        if ($db->rows_affected > 0) {
            echo '<p id="p'.rnum().'" class="fade notice">Cover photo for the album <strong>'.$album_title.'</strong> has been set.</p>';
        }


        echo '<ol>';
        echo '<li><a href="'.$self.'?op=edit-photo&amp;id='.$photo_id.'&amp;album_id='.$album_id.'">Edit the photo</a></li>';
        echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Return to its album</a></li>';
        echo '<li><a href="'.$self.'">Return to albums</a></li>';
        echo '</ol>';


        // modify last edit time of album
        touch_album($album_id);

        break;
    }










    case 'delete-photo': { //*
    // 2005-05-02 00:55:00

        $album_id = intval(strip_tags($_REQUEST['album_id']));
        $id = intval(strip_tags($_REQUEST['id']));


        echo '<h2>Remove photo from album</h2>';

        if (isset($_REQUEST['confirm'])) {

            $album_title = $db->get_var("SELECT title FROM $table_albums WHERE ID='$album_id'");
            $photo_title = $db->get_var("SELECT title FROM $table_photos WHERE ID='$id'");

            $sql = "DELETE FROM $table_photos WHERE ID='$id' ";
            $db->query($sql);
            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">The photo <strong>'.$photo_title.'</strong> has been removed from the album <strong>'.$album_title.'</strong>.</p>';
            }


            $sql = "SELECT cover_image FROM $table_albums WHERE ID='$album_id' ";
            $cover_image = $db->get_var($sql);
            if ( $cover_image == $id ) {
                $sql = "UPDATE $table_albums SET "
                        ." cover_image='0' "
                        ." WHERE ID='$album_id' ";
                $db->query($sql);
            }


            echo '<ol>';
            echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Return to the album</a></li>';
            echo '<li><a href="'.$self.'">Return to albums</a></li>';
            echo '</ol>';



        } else {


            $album_title = $db->get_var("SELECT title FROM $table_albums WHERE ID='$album_id'");
            $photo_title = $db->get_var("SELECT title FROM $table_photos WHERE ID='$id'");

            echo '<p>Are you sure you want to remove the photo <strong>'.$photo_title.'</strong> from the <strong>'.$album_title.'</strong> album?</p>';

            echo '<p>Note that deleting a photo from the album does not
                    delete it from the <code>uploads</code> database.</p>';


            echo '<ol>';
            echo '<li><a href="'.$self.'?op=delete-photo&amp;confirm=1&amp;id='.$id.'&amp;album_id='.$album_id.'">Yes, remove the photo</a></li>';
            echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">No, return to the album</a></li>';
            echo '<li><a href="'.$self.'">Return to albums</a></li>';
            echo '</ol>';


        }
        break;
    }








    case 'clone-photo': { //*
    // 2005-05-02 00:55:10


        $album_id = intval(strip_tags($_GET['album_id']));
        $photo_id = intval(strip_tags($_GET['photo_id']));
        $prev_album_id = intval(strip_tags($_GET['prev_album_id']));


        if (isset($_REQUEST['confirm'])) {

            $album_title = $db->get_var("SELECT title FROM $table_albums WHERE ID='$album_id'");
            $photo = $db->get_row("SELECT * FROM $table_photos WHERE ID='$photo_id'");


            echo '<h2>Clone '.$photo_title.' to '.$album_title.'</h2>';


            $sql = " SELECT ID FROM $table_photos "
                    ." WHERE upload_id='$photo->upload_id'  "
                    ." AND album_id='$album_id' ";
            $check_id = $db->get_var($sql);

            if ( $check_id ) {
                echo 'The photo <strong>'.$photo->title.'</strong> is already in this album.';

                echo '<ol>';
                echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$prev_album_id.'">Go back to its source album</a></li>';
                echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Go to its target album</a></li>';
                echo '<li><a href="'.$self.'">Return to albums</a></li>';
                echo '</ol>';


            } else {
                if ( isset($album_id) && isset($photo_id) ) {

                    $sql = " SELECT MAX(sort_order) FROM $table_albums "
                            ." WHERE ID='$album_id' ";
                    $counter = intval($db->get_var($sql)) + 10;


                    $sql = " INSERT INTO $table_photos SET "
                            ." sort_order='$counter', "
                            ." upload_id='$photo->upload_id', "
                            ." album_id='$album_id', "
                            ." title='$photo->title', "
                            ." caption='$photo->caption', "
                            ." visible='$photo->visible', "
                            ." date_created='$now_timestamp', "
                            ." date_edited='$now_timestamp', "
                            ." date_taken='$photo->date_taken' ";
                    $db->query($sql);

                    if ($db->rows_affected > 0) {
                        echo '<p id="p'.rnum().'" class="fade notice">The photo <strong>'.$photo->title.'</strong> has been copied to the <strong>'.$album_title.'</strong> album.</p>';
                    }


                    // modify last edit time of album
                    touch_album($album_id);


                    echo '<ol>';
                    echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$prev_album_id.'">Go to its source album</a></li>';
                    echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Go to its new album</a></li>';
                    echo '<li><a href="'.$self.'">Return to albums</a></li>';
                    echo '</ol>';




                }
            }



        } else {



            $photo = $db->get_row("SELECT title, upload_id FROM $table_photos WHERE ID='$photo_id'");
            $filename = $db->get_var("SELECT filename FROM $table_uploads WHERE ID='$photo->upload_id'");



            echo '<h2>Clone '.$photo->title.' to another photo album</h2>';
            echo '<p><img src="../'.$path_photos.$filename.'" /></p>';


            $albums = $db->get_results("SELECT ID, title FROM $table_albums WHERE ID!='$album_id'");



            echo '<ol>';
            foreach ($albums as $album) {
                echo '<li><a href="'.$self.'?op=clone-photo&amp;confirm=1&amp;prev_album_id='.$album_id.'&amp;album_id='.$album->ID.'&amp;photo_id='.$photo_id.'">Clone this photo to the  <strong>'.stripslashes($album->title).'</strong> album</a></li>';
            }
            echo '</ol>';


            echo '<ol>';
            echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Go back to its album</a></li>';
            echo '<li><a href="'.$self.'">Return to albums</a></li>';
            echo '</ol>';


        }

        break;
    }











    case 'reset-thumbnail': { //*
    // 2005-05-02 01:33:32

        if (isset($_REQUEST['confirm'])) {


            $album_id = intval(strip_tags($_GET['album_id']));
            $upload_id = intval(strip_tags($_GET['upload_id']));


            $sql = " SELECT ID, filename FROM $table_uploads "
                    ." WHERE ID='$upload_id' ";
            $upload = $db->get_row($sql);


            echo '<h2>Reset Thumbnail</h2>';




            //set_thumbnail($res[0]['filename'], $_REQUEST['t']);


            // function fork! =============


            //global $thumbnail_quality, $thumbnail_size, $path_photos, $path_temp;

            $img = $upload->filename;
            $t = $_REQUEST['t'];


            $image_path = '../'.$path_photos.$img;
            $copy_file = '../'.$path_photos.$thumbnail_prefix.$img;

            $size = getimagesize($image_path);


            if ($size[0] > $size[1]) {
                $orientation = 'landscape';
                if ($t == 'w') {
                    if (copy('../'.$path_temp.'w_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                } elseif ($t == 'c') {
                    if (copy('../'.$path_temp.'c_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                } elseif ($t == 'e') {
                    if (copy('../'.$path_temp.'e_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                }
                unlink('../'.$path_temp.'w_thumb__'.$img);
                unlink('../'.$path_temp.'c_thumb__'.$img);
                unlink('../'.$path_temp.'e_thumb__'.$img);
            } elseif ($size[0] < $size[1]) {
                $orientation = 'portrait';
                if ($t == 'n') {
                    if (copy('../'.$path_temp.'n_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                } elseif ($t == 'c') {
                    if (copy('../'.$path_temp.'c_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                } elseif ($t == 's') {
                    if (copy('../'.$path_temp.'s_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                }
                unlink('../'.$path_temp.'n_thumb__'.$img);
                unlink('../'.$path_temp.'c_thumb__'.$img);
                unlink('../'.$path_temp.'s_thumb__'.$img);
            } elseif ($size[0] == $size[1]) {
                $orientation = 'square';
                if ($t == 'c') {
                    if (copy('../'.$path_temp.'c_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                }
                unlink('../'.$path_temp.'c_thumb__'.$img);
            }



            echo '<ol>';
            if ($album_id > 0) {
                echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Return to the photo&#8217;s album</a></li>';
            }
            echo '<li><a href="'.$self.'">Return to albums</a></li>';
            echo '</ol>';




        } else {

            $album_id = intval(strip_tags($_GET['album_id']));
            $upload_id = intval(strip_tags($_GET['upload_id']));


            $sql = " SELECT ID, filename FROM $table_uploads "
                    ." WHERE ID='$upload_id' ";
            $upload = $db->get_row($sql);

            echo '<h2>Reset Thumbnail</h2>';



            //make_thumbnails($res[0]['filename'], $res[0]['id']);

            // function fork! =============

            //global $thumbnail_quality, $thumbnail_size, $path_photos, $path_temp;


            $img = $upload->filename;
            $id = $upload->ID;


            $image_path = '../'.$path_photos.$img;

            $size = getimagesize($image_path);


            if ($size[0] > $size[1]) {
                $orientation = 'landscape';
                // w
                $w_src_x = 0;
                $w_src_y = 0;

                // c
                $c_src_y = 0;
                $c_src_x = intval(($size[0] - $size[1])/2);

                // e
                $e_src_y = 0;
                $e_src_x = $size[0] - $size[1];

                $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

                // west thumbnail
                $w_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($w_thumb, $src_img, 0, 0, $w_src_x ,$w_src_y, $thumbnail_size, $thumbnail_size, $size[1], $size[1]);
                imagejpeg($w_thumb, '../'.$path_temp.'w_thumb__'.$img, $thumbnail_quality);
                imagedestroy($w_thumb);

                // center thumbnail
                $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[1], $size[1]);
                imagejpeg($c_thumb, '../'.$path_temp.'c_thumb__'.$img, $thumbnail_quality);
                imagedestroy($c_thumb);

                // east thumbnail
                $e_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($e_thumb, $src_img, 0, 0, $e_src_x ,$e_src_y, $thumbnail_size, $thumbnail_size, $size[1], $size[1]);
                imagejpeg($e_thumb, '../'.$path_temp.'e_thumb__'.$img, $thumbnail_quality);
                imagedestroy($e_thumb);

                imagedestroy($src_img);


            } elseif ($size[0] < $size[1]) {
                $orientation = 'portrait';
                // n
                $n_src_x = 0;
                $n_src_y = 0;

                // c
                $c_src_y = intval(($size[1] - $size[0])/2);
                $c_src_x = 0;

                // s
                $s_src_y = $size[1] - $size[0];
                $s_src_x = 0;

                $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

                // north thumbnail
                $n_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($n_thumb, $src_img, 0, 0, $n_src_x ,$n_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
                imagejpeg($n_thumb, '../'.$path_temp.'n_thumb__'.$img, $thumbnail_quality);
                imagedestroy($n_thumb);

                // center thumbnail
                $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
                imagejpeg($c_thumb, '../'.$path_temp.'c_thumb__'.$img, $thumbnail_quality);
                imagedestroy($c_thumb);

                // south thumbnail
                $s_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($s_thumb, $src_img, 0, 0, $s_src_x ,$s_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
                imagejpeg($s_thumb, '../'.$path_temp.'s_thumb__'.$img, $thumbnail_quality);
                imagedestroy($s_thumb);

                imagedestroy($src_img);






            } elseif ($size[0] == $size[1]) {
                $orientation = 'square';
                // c
                $c_src_y = 0;
                $c_src_x = 0;

                $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

                // center thumbnail
                $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
                imagejpeg($c_thumb, '../'.$path_temp.'c_thumb__'.$img, $thumbnail_quality);
                imagedestroy($c_thumb);

                imagedestroy($src_img);

            }





            echo '<table><tr>';


            echo '<th colspan="3"><h3>'.$img.' ('.$orientation.')</h3>Choose a thumbnail:</th>';

                if ($orientation == 'landscape') {
                    echo '<tr>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;upload_id='.$id.'&amp;album_id='.$album_id.'&amp;t=w"><img src="../'.$path_temp.'w_thumb__'.$img.'" /><br /> left-aligned</a></td>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;upload_id='.$id.'&amp;album_id='.$album_id.'&amp;t=c"><img src="../'.$path_temp.'c_thumb__'.$img.'" /><br /> centered</a></td>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;upload_id='.$id.'&amp;album_id='.$album_id.'&amp;t=e"><img src="../'.$path_temp.'e_thumb__'.$img.'" /><br /> right-aligned</a></td>';
                    echo '</tr>';
                }

                if ($orientation == 'portrait') {
                    echo '<tr>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;upload_id='.$id.'&amp;album_id='.$album_id.'&amp;t=n"><img src="../'.$path_temp.'n_thumb__'.$img.'" /><br /> top-aligned</a></td>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;upload_id='.$id.'&amp;album_id='.$album_id.'&amp;t=c"><img src="../'.$path_temp.'c_thumb__'.$img.'" /><br /> centered</a></td>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;upload_id='.$id.'&amp;album_id='.$album_id.'&amp;t=s"><img src="../'.$path_temp.'s_thumb__'.$img.'" /><br /> bottom-aligned</a></td>';
                    echo '</tr>';
                }

                if ($orientation == 'square') {
                    echo '<tr>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;upload_id='.$id.'&amp;album_id='.$album_id.'&amp;t=c"><img src="../'.$path_temp.'c_thumb__'.$img.'" /><br /> centered</a></td>';
                    echo '</tr>';
                }

            echo '</tr></table>';


            echo '<ol>';
            echo '<li><a href="'.$self.'?op=edit-album&amp;album_id='.$album_id.'">Return to the photo&#8217;s album</a></li>';
            echo '<li><a href="'.$self.'">Return to albums</a></li>';
            echo '</ol>';




        }




        break;
    }




    //* tools --------------------------------------------------------------
    //*   disabled for first mysql development version












    case 'tools-delete-upload' : { //*
    // 2005-05-03 00:32:06
    //sql

        $upload_id = intval(strip_tags($_GET['upload_id']));
        $sql = " SELECT filename FROM $table_uploads "
                ." WHERE ID='$upload_id' ";
        $upload = $db->get_row($sql);


        echo '<h2>Delete Upload</h2>';
        //echo $tool_menu;


        if (!isset($_REQUEST['confirm'])) {

            echo '<p>Deleting the upload <strong>'.$upload->filename.'</strong> will also delete it in all photo albums
                    it is currently in. Are you sure?</p>';

            echo '<p><strong><a href="'.$self.'?op=tools-delete-upload&amp;confirm=1&amp;id='.$upload_id.'">Yes, delete the photo</a>.</strong></p>';

            echo '<ol>';
            echo '<li><a href="'.$self.'?op=tools-inbox">Return to uploads</a></li>';
            echo '</ol>';



        } else {


            $sql = " SELECT album_id FROM $table_photos "
                    ." WHERE upload_id='$upload_id' ";
            $affected_albums = $db->get_results($sql);


            $sql = " DELETE FROM $table_photos "
                    ." WHERE upload_id='$upload_id' ";
            $db->query($sql);
            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">Upload deleted from <code>photos</code> database.</p>';
            }

            $sql = " DELETE FROM $table_uploads "
                    ." WHERE ID='$upload_id' ";
            $db->query($sql);
            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">Upload deleted from <code>uploads</code> database.</p>';
            }


            foreach ($affected_albums as $album) {
                    touch_album($album->album_id);
            }


            @unlink('../'.$path_photos.$upload->filename);
            @unlink('../'.$path_photos.$thumbnail_prefix.$upload->filename);

            echo '<ol>';
            echo '<li><a href="'.$self.'?op=tools-inbox">Return to uploads</a></li>';
            echo '</ol>';




            // delete for other thumbnails must be here!
            // use preg_match for possible delete()
            // or load all photos in album, if strpos() filename, delete

            // modify last edit time of album should be here!
            //touch_album($_REQUEST['album_id']); // cannot stay inside loop!

            //echo '<p>The photo <strong>'.$upload->filename.'</strong> has been deleted.</p>';

        }

        break;
    }












    case 'tools-copy-to-album' : { //*
    // 2005-05-03 00:49:15
    //sql

        $upload_id = intval(strip_tags($_GET['upload_id']));

        echo '<h2>Copy to album</h2>';
        //echo $tool_menu;


        if (!isset($_REQUEST['confirm'])) {

            $sql = " SELECT * FROM $table_uploads "
                    ." WHERE ID='$upload_id' ";
            $upload = $db->get_row($sql);

            echo '<p><img src="../'.$path_photos.$upload->filename.'" /></p>';


            $sql = " SELECT ID, title FROM $table_albums ";
            $albums = $db->get_results($sql);

            $sql = " SELECT album_id FROM $table_photos "
                    ." WHERE upload_id='$upload_id' ";
            $photo_in_albums = $db->get_results($sql);

            $albums_arr = array();
            if ($photo_in_albums) {
                foreach ($photo_in_albums as $album) {
                    $albums_arr[] = $album->album_id;
                }
            }

            echo '<p>Photo: <strong>'.$upload->filename.'</strong></p>';


            echo '<ol>';
            foreach ($albums as $album) {
                if ( !in_array($album->ID, $albums_arr) ) {
                    echo '<li><a href="'.$self.'?op=tools-copy-to-album&amp;confirm=1&amp;target='.$album->ID.'&amp;upload_id='.$upload_id.'">copy this photo to the  <strong>'.$album->title.'</strong> album</a></li>';
                }
            }
            echo '</ol>';


            echo '<ol>';
            echo '<li><a href="'.$self.'?op=tools-inbox">Return to uploads</a></li>';
            echo '</ol>';


        } else {


            $target = intval(strip_tags($_GET['target']));
            $upload_id = intval(strip_tags($_GET['upload_id']));

            $sql = " SELECT ID FROM $table_photos "
                    ." WHERE album_id='$target' "
                    ." AND upload_id='$upload_id' ";
            $upload = $db->get_var($sql);


            if ( isset($target) && isset($upload_id) && !$upload ) {

                $sql = " SELECT * FROM $table_uploads "
                        ." WHERE ID='$upload_id' ";
                $upload = $db->get_row($sql);

                $sql = " SELECT MAX(sort_order) FROM $table_photos WHERE album_id='$target' ";
                $counter = intval($db->get_var($sql)) + 10;

                require_once '../'.$path_lib.'class.exif.php';
                $exif = new ipap_exif('../'.$path_photos.$upload->filename);
                $exif->process_file();
                if ( strlen($exif->get_exif_date()) > 0 ) {
                    $new_date_taken = reformat_exif_date($exif->get_exif_date());
                } else {
                    $new_date_taken = date('Y-m-d H:i:s', filemtime('../'.$path_photos.$upload->filename) + (3600*$server_time_offset));
                    //$new['date_taken'] = '';
                }


                $sql = " INSERT INTO $table_photos SET "
                        ."title='$upload->filename', "
                        ."upload_id='$upload_id', "
                        ."album_id='$target', "
                        ."sort_order='$counter', "
                        ."date_taken='$new_date_taken', "
                        ."date_created='$now_timestamp', "
                        ."date_edited='$now_timestamp' ";
                $db->query($sql);
                if ($db->rows_affected > 0) {
                    echo '<p id="p'.rnum().'" class="fade notice">The photo <strong>'.$upload->filename.'</strong> has been copied to the <strong>'.$upload->title.'</strong> album.</p>';
                }

                // modify last edit time of album
                touch_album($target);


                echo '<ol>';
                echo '<li><a href="'.$self.'?op=tools-inbox">Return to uploads</a></li>';
                echo '</ol>';


            } else {
                echo '<p id="p'.rnum().'" class="fade notice">The photo is already in this album.</p>';

                echo '<ol>';
                echo '<li><a href="'.$self.'?op=tools-inbox">Return to uploads</a></li>';
                echo '</ol>';
                
            }

        }

        break;
    }








    case 'tools-inbox' : { //*
    // 2005-05-02 05:19:10
    //sql



        $sql = " SELECT * FROM $table_uploads ";
        $uploads = $db->get_results($sql);


        if (!$_REQUEST['mode'] == 'all' && count($uploads) > 10) {
            $uploads = array_slice($uploads, 0, 10);
        } elseif (!$_REQUEST['mode'] == 'next20' && count($uploads) > 30) {
            $uploads = array_slice($uploads, 10, 20);
        }


        echo '<h2>List Uploads</h2>';
        //echo $tool_menu;

            echo '<p><strong>copy</strong> - Copy to an album.<br />
                        <strong>thumbnail</strong> - Re-select a thumbnail for this photo.<br />
                        <strong>delete</strong> - Delete photo from the database (and all albums it is contained in!).
                    </p>';


        echo '<p><a href="'.$self.'?op=tools-inbox">10 most recent uploads</a> |
            <a href="'.$self.'?op=tools-inbox&amp;mode=next20">next 20 uploads</a> |
            <a href="'.$self.'?op=tools-inbox&amp;mode=all">all uploads</a>
        </p>';


        echo '<table>
        <tr>
            <th>ID</th>
            <th>Thumbnail</th>
            <th>Filename</th>
            <th>Width</th>
            <th>Height</th>
            <th>Info</th>
        </tr>
        ';

        foreach ($uploads as $value) {

            if (!file_exists('../'.$path_photos.$thumbnail_prefix.$value->filename)) {
                auto_thumbnail($value->filename);
            }
            $img = '<img src="../'.$path_photos.$thumbnail_prefix.$value->filename.'" />';


            $dne = '';
            if (!file_exists('../'.$path_photos.$value->filename)) {
                $dne = '<br /> Photo does not exist!';
            }

            $found_in = '<br />Included in:';
            $in_gal = 0;

            $sql = " SELECT a.ID, a.title FROM $table_photos p "
                    ." LEFT JOIN $table_albums a "
                    ." ON p.album_id=a.ID "
                    ." WHERE p.upload_id='$value->ID' ";

            $albums = $db->get_results($sql);

            if ($albums) {
                $in_gal = 1;
                foreach ($albums as $album) {
                    $found_in .= '<br /><a href="'.$self.'?op=edit-album&amp;album_id='.$album->ID.'">'.$album->title.'</a>';
                }

            }



            if (!$in_gal) {
                $found_in = '<br /><strong>Not in any album!</strong>';
            }


            echo '<tr>
                <td>'.$value->ID.'</td>
                <td> '.$img.'</td>
                <td>'.truncate($value->filename, 16, '...',1).$dne.'</td>
                <td> '.$value->width.'</td>
                <td> '.$value->height.'</td>
                <td>
                    <p class="actions">
                        Uploaded: '.date($gallery_date_format, strtotime($value['date_uploaded'])).$found_in.'

                        <br />
                        <br />
                        <a href="'.$self.'?op=tools-copy-to-album&amp;upload_id='.$value->ID.'">copy</a> &#183;
                        <a href="'.$self.'?op=reset-thumbnail&amp;upload_id='.$value->ID.'">thumbnail</a> &#183;
                        <a href="'.$self.'?op=tools-delete-upload&amp;upload_id='.$value->ID.'">delete</a>
                    </p>
                </td>
            </tr>';

        }

        echo '</table>';


        break;
    }









    //* labels -------------------------------------------------------------


    case 'edit-label-sort' : { //*
    // 2005-05-02 02:32:47

        echo '<h2>Labels</h2>';

        $sql = " SELECT * FROM $table_labels ";
        $labels = $db->get_results($sql);

        foreach ($labels as $label) {
            unset($new_sort_order, $new_visible);

            isset($_REQUEST['sort_'.$label->ID]) ? $new_sort_order = format_to_post($_REQUEST['sort_'.$label->ID]) : $new_sort_order = '';
            isset($_REQUEST['visible_'.$label->ID]) ? $new_visible = 'Y' : $new_visible = 'N';


            $sql = " UPDATE $table_labels SET "
                    ." sort_order='$new_sort_order', "
                    ." visible='$new_visible' "
                    ." WHERE ID=$label->ID ";
            $db->query($sql);

            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">Updated sort order and visibility info for label '.$label->label.'.</p>';
            }


        }

        echo '<ol>';
        echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
        echo '</ol>';



        break;
    }












    case 'edit-label': { //*
    // 2005-05-02 02:16:49

        $label_id = intval(strip_tags($_REQUEST['label_id']));


        if (isset($_REQUEST['save_info'])) {

            $sql = " SELECT * FROM $table_labels "
                    ." WHERE ID='$label_id' ";
            $label = $db->get_row($sql);


            echo '<h2>Editing label: '.$label->label.'</h2>';

            $new_label = format_to_post($_POST['label_name']);
            $new_description = format_to_post($_POST['label_description']);
            $new_sort_order = format_to_post($_POST['label_sort_order']);

            isset($_POST['label_visible']) ? $new_visible = 'Y' : $new_visible = 'N';


           $sql = " UPDATE $table_labels SET "
                    ." label='$new_label', "
                    ." description='$new_description', "
                    ." date_edited='$new_date_edited', "
                    ." sort_order='$new_sort_order', "
                    ." visible='$new_visible' "
                    ." WHERE ID='$label_id' ";
            $db->query($sql);

            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">The label <strong>'.$new_label.'</strong> has been edited.</p>';
            }


            echo '<ol>';
            echo '<li><a href="'.$self.'?op=edit-label&amp;label_id='.$label_id.'">Continue editing this label</a></li>';
            echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
            echo '</ol>';


        } else {

            $sql = " SELECT * FROM $table_labels "
                    ." WHERE ID='$label_id' ";
            $label = $db->get_row($sql);
            ?>

            <h2>Editing label: <?php echo $label->label; ?></h2>

            <p>Special characters in the <strong>label</strong> and <strong>description</strong>
            field are automatically converted to their markup equivalents. In addition, linebreaks
            in the description are automatically converted. A <strong>single linebreak for a new line</strong>, <strong>two
            linebreaks to start a new paragraph</strong>.
            </p>

            <form enctype="multipart/form-data" method="post" action="<?php echo $self; ?>?op=edit-label">
            <input type="hidden" name="label_id" value="<?php echo $label->ID; ?>" />
            <input type="hidden" name="save_info" />

            <p><label for="label_name">Label:</label><br /><input type="text" id="label_name" name="label_name" size="50" value="<?php echo $label->label; ?>" /></p>


            <p><label for="label_description">Description:</label><br /><textarea id="label_description" name="label_description" rows="10" cols="50"><?php echo $label->description; ?></textarea>
            <!-- dunstan's increase/decrease textarea. thanks, mate! -->
            <script type="text/javascript">
            <!--
            document.write('<br />');
            document.write('<small>(Textarea: <span style="cursor: pointer;" onclick="document.getElementById(\'label_description\').rows += 5;" title="Click to enlarge the  textarea">Increase size</span> | <span style="cursor: pointer;" onclick="document.getElementById(\'label_description\').rows -= 5;" title="Click to decrease the textarea">Decrease size</span>)</small>');
            //-->
            </script>

            </p>

            <p><label for="label_sort_order">Sort Order:</label><br /><input type="text" id="label_sort_order" name="label_sort_order" size="10" value="<?php echo $label->sort_order; ?>" /></p>

            <?php
            $label->visible == 'Y' ? $checked = 'checked="checked"' : $checked = '';
            ?>

            <p><label for="label_visible">Visible?</label><br /><input type="checkbox" id="label_visible" name="label_visible" <?php echo $checked; ?> /></p>

            <input class="mysubmit" type="submit" name="Submit" value="Save changes" />
            </form>


            <?php


        }
        break;
    }









    case 'add-label' : { //*
    // 2005-05-02 01:58:06


        $new_label = stripslashes($_POST['label']);
        $new_slug = sanitize_title($new_label);

        $c1 = $db->get_var("SELECT label FROM $table_labels WHERE label='".$new_label."'");
        $c2 = $db->get_var("SELECT slug FROM $table_labels WHERE slug='".$new_slug."'");


        echo '<h2>Add label</h2>';
        if ( isset($_REQUEST['makecheck']) ) {

            if ( strlen($new_label) == 0 || strlen($new_slug) == 0 ) {
                echo '<p id="p'.rnum().'" class="fade notice">The length of the label&#8217;s <strong>name</strong> and <strong>slug</strong> must be at least 1 character.</p>';

                echo '<ol>';
                echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
                echo '</ol>';


            } elseif (  $c1 || $c2 && strlen($new_label) > 0 && strlen($new_slug) > 0  ) {
                echo '<p>A label with the same <strong>name</strong> or <strong>slug</strong> already exists.</p>';

                echo '<ol>';
                echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
                echo '</ol>';


            } else {

                $sql = "SELECT MAX(sort_order) FROM $table_labels";
                $counter = intval($db->get_var($sql)) + 10;


                $sql = " INSERT INTO $table_labels SET "
                        ."label='$new_label', "
                        ."slug='$new_slug', "
                        ."sort_order='$counter', "
                        ."date_created='$now_timestamp', "
                        ."date_edited='$now_timestamp' ";
                $db->query($sql);
                if ($db->rows_affected > 0) {
                    echo '<p id="p'.rnum().'" class="fade notice">The label <strong>'.$new_label.'</strong> has been created.</p>';
                }



                echo '<ol>';
                echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
                echo '</ol>';


            }

        }

        break;
    }










    case 'delete-label' : { //*
    // 2005-05-02 02:25:33

        $label_id = intval(strip_tags($_REQUEST['label_id']));



        echo '<h2>Delete Label</h2>';

        if (isset($_REQUEST['confirm'])) {

            if ( isset($_REQUEST['label_id']) ) {


                $label_name = $db->get_var("SELECT label FROM $table_labels WHERE ID='$label_id' ");

                $sql = " DELETE FROM $table_labelsrel WHERE label_id='$label_id' ";
                $db->query($sql);

                $sql = " DELETE FROM $table_labels WHERE ID='$label_id' ";
                $db->query($sql);

                if ($db->rows_affected > 0) {
                    echo '<p id="p'.rnum().'" class="fade notice">The label <strong>'.$label_name.'</strong> has been deleted.</p>';
                }

                echo '<ol>';
                echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
                echo '</ol>';


            }

        } else {
            echo '<p>Are you sure you want to delete this label?</p>';

//            echo '<p>Deleting an album also deletes all instances of photos
//                    within the album, but these photos are still kept
//                    in the <code>uploads</code> database.</p>';


            echo '<ol>';
            echo '<li><a href="'.$self.'?op=delete-label&amp;confirm=1&amp;label_id='.$label_id.'">Yes, delete the label</a></li>';
            echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
            echo '</ol>';


        }


        break;
    }











    case 'remove-label' : { //*
    // 2005-05-02 04:22:11

        $label_id = intval(strip_tags($_REQUEST['label_id']));
        $album_id = intval(strip_tags($_REQUEST['album_id']));
        $rel_id = intval(strip_tags($_REQUEST['rel_id']));


        $label = $db->get_var(" SELECT label FROM $table_labels WHERE ID='$label_id' ");
        $album = $db->get_var(" SELECT title FROM $table_albums WHERE ID='$album_id' ");



        echo '<h2>Remove label</h2>';

        if (isset($_REQUEST['confirm'])) {


            $sql = "DELETE FROM $table_labelsrel WHERE ID='$rel_id' ";
            $db->query($sql);
            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">Label <strong>'.$label.'</strong> removed from album <strong>'. $album.'</strong>.</p>';
            }

            echo '<ol>';
            echo '<li><a href="'.$self.'?op=view-label&amp;label_id='.$label_id.'">View label <strong>'.$label.'</strong> again</a></li>';
            echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
            echo '</ol>';


        } else { // get confirmation


            echo '<p>Are you sure you want to remove the label <strong>'.$label.'</strong> from the album <strong>'. $album.'</strong>?</p>';


            echo '<ol>';
            echo '<li><a href="'.$self.'?op=remove-label&amp;confirm=1&amp;rel_id='.$rel_id.'&amp;album_id='.$album_id.'&amp;label_id='.$label_id.'">Yes, remove the label</a></li>';
            echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
            echo '</ol>';


        }

        break;
    }












    case 'attach-label' : { //*
    // 2005-05-02 04:08:59


        $label_id = intval(strip_tags($_REQUEST['label_id']));
        $album_id = intval(strip_tags($_REQUEST['album_id']));

        echo '<h2>Attach label</h2>';


        $label = $db->get_var(" SELECT label FROM $table_labels WHERE ID='$label_id' ");
        $album = $db->get_var(" SELECT title FROM $table_albums WHERE ID='$album_id' ");

        $check_id = $db->get_var(" SELECT ID FROM $table_labelsrel WHERE label_id='$label_id' AND album_id='$album_id' ");

        if ($check_id) {
            echo '<p id="p'.rnum().'" class="fade notice">Label <strong>'.$label.'</strong> already attached to album <strong>'. $album.'</strong>.</p>';

            echo '<ol>';
            echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
            echo '</ol>';


        } else {

            $counter = $db->get_var(" SELECT MAX(sort_order) FROM $table_labelsrel WHERE label_id='$label_id' ");
            $counter = intval($counter) + 10;


            $sql = " INSERT INTO $table_labelsrel SET "
                    ." sort_order='$counter', "
                    ." album_id='$album_id', "
                    ." label_id='$label_id' ";
            $db->query($sql);

            if ($db->rows_affected > 0) {
                echo '<p id="p'.rnum().'" class="fade notice">Label <strong>'.$label.'</strong> attached to the album <strong>'.$album.'</strong>.</p>';
            }


            echo '<ol>';
            echo '<li><a href="'.$self.'?op=view-label&amp;label_id='.$label_id.'">View label <strong>'.$label.'</strong> again</a></li>';
            echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
            echo '</ol>';


        }


        break;
    }










    case 'view-label' : { //*
    // 2005-05-02 04:02:54


        $label_id = intval(strip_tags($_REQUEST['label_id']));


        $label = $db->get_var(" SELECT label FROM $table_labels WHERE ID='$label_id' ");



        $sql = " SELECT r.ID, a.ID as album_id, a.title, r.sort_order "
                ." FROM $table_labelsrel r "
                ." LEFT JOIN $table_albums a "
                ." ON r.album_id=a.ID "
                ." WHERE r.label_id='$label_id' "
                ." ORDER BY r.sort_order DESC";

        $att_albums = $db->get_results($sql);


        echo '<h2>View Label: '.$label.'</h2>';


        echo '<p><strong>sort_order</strong> - Used for display sequence of photo albums.
                    Reversed sort (highest first) for albums.<br /></p>';


        if ($att_albums) {
            echo '<form enctype="multipart/form-data" method="post" action="'.$self.'?op=sort-a-label">';
            echo '<input type="hidden" name="label_id" value="'.$label_id.'" />';
            echo '<p><strong>Currently attached to album(s):</strong></p>';
            echo '<ol>';
            foreach ($att_albums as $att_album) {
                echo '<li><input type="text" name="sort_'.$att_album->ID.'" value="'.$att_album->sort_order.'" size="5" /> [ <a href="'.$self.'?op=remove-label&amp;rel_id='.$att_album->ID.'&amp;album_id='.$att_album->album_id.'&amp;label_id='.$label_id.'">remove</a> ] '.$att_album->title.'</li>';
            }
            echo '</ol>';
            echo '<p><input class="mysubmit" type="submit" name="Submit" value="Save changes to sort order" /></p>';
            echo '</form>';
        }


        $sql = " SELECT album_id FROM $table_labelsrel "
                ." WHERE label_id='$label_id' ";
        $att = $db->get_results($sql);
        $att_id = array();
        if ($att) {
            foreach ($att as $album) {
                $att_id[] = $album->album_id;
            }
        }


        $sql = " SELECT ID, title FROM $table_albums ";
        $albums = $db->get_results($sql);


        echo '<p><strong>Attach to album(s):</strong></p>';

        echo '<ol>';
        foreach ($albums as $album) {
            if (!in_array($album->ID, $att_id)) {
                echo '<li>[ <a href="'.$self.'?op=attach-label&amp;confirm=1&amp;album_id='.$album->ID.'&amp;label_id='.$label_id.'">attach</a> ] '.$album->title.'</li>';
            }
        }
        echo '</ol>';


        echo '<ol>';
        echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
        echo '</ol>';



        break;
    }










    case 'sort-a-label' : { //*
    // 2004-08-30 15:52:18


        $label_id = intval(strip_tags($_REQUEST['label_id']));

        echo '<h2>Sort a label</h2>';

        $label = $db->get_var(" SELECT label FROM $table_labels WHERE ID='$label_id' ");


        $sql = " SELECT ID, album_id FROM $table_labelsrel "
                ." WHERE label_id='$label_id' ";
        $res = $db->get_results($sql);


        foreach ($res as $value) {
            unset($new);
            if (  isset($_REQUEST['sort_'.$value->ID])  ) {
                $new_sort_order = stripslashes($_REQUEST['sort_'.$value->ID]);

                $album = $db->get_var(" SELECT title FROM $table_albums WHERE ID='$value->album_id' ");

                $sql = " UPDATE $table_labelsrel SET "
                        ." sort_order='$new_sort_order' "
                        ." WHERE ID='$value->ID' ";
                $db->query($sql);
                if ($db->rows_affected > 0) {
                    echo '<p id="p'.rnum().'" class="fade notice">Sort order edited for <strong>'.$photo->title.'</strong> in the label <strong>'.$label.'</strong>.</p>';
                }

            }
        }

        echo '<ol>';
        echo '<li><a href="'.$self.'?op=labels">Return to labels</a></li>';
        echo '</ol>';



        break;
    }













    case 'labels' : { //*
    // 2005-05-02 01:59:08

        $sql = " SELECT * FROM $table_labels ";
        $labels = $db->get_results($sql);


        if ($labels) {
        ?>


            <h2>Current Labels</h2>

            <form enctype="multipart/form-data" method="post" action="<?php echo $self; ?>?op=edit-label-sort">

            <p>
                <a href="#" onclick="toggle('list-labels-help');return false;" title="Hide or show help (below).">Help?</a>
            </p>


            <ul id="list-labels-help" style="display:none;">
                <li><strong>sort_order</strong> &#8594; Display sequence of labels. Numerically sorted (lowest first).</li>
                <li><strong>visible</strong> &#8594; Uncheck to hide label.</li>
                <li><strong>view</strong> &#8594; View (and add) this label to albums.</li>
                <li><strong>edit</strong> &#8594; Edit label&#8217;s details.</li>
                <li><strong>delete</strong> &#8594; Delete label.</li>
            </ul>

            <table width="100%">
            <tr>
                <th>Sort order</th>
                <th>Visible?</th>
                <th>Label</th>
            </tr>

        <?php

            foreach ($labels as $label) {

                $label->visible == 'Y' ? $checked = 'checked="checked"' : $checked = '';
                ?>


                <tr>
                    <td><input type="text" id="sort_<?php echo $label->ID; ?>" name="sort_<?php echo $label->ID; ?>" size="4" value="<?php echo format_to_edit($label->sort_order); ?>" /></td>
                    <td><input type="checkbox" id="visible_<?php echo $label->ID; ?>" name="visible_<?php echo $label->ID; ?>" <?php echo $checked; ?> /></td>
                    <td><?php echo $label->label; ?>
                    <p class="actions">
                        <a href="<?php echo $self; ?>?op=view-label&amp;label_id=<?php echo $label->ID; ?>" title="View label and list of albums it is attached to.">view</a> &#183;
                        <a href="<?php echo $self; ?>?op=edit-label&amp;label_id=<?php echo $label->ID; ?>" title="Edit label details.">edit</a> &#183;
                        <a href="<?php echo $self; ?>?op=delete-label&amp;label_id=<?php echo $label->ID; ?>" title="Delete label.">delete</a>
                    </p>
                    </td>

                  <!--   <td><a href="<?php echo $self; ?>?op=view-label&amp;label_id=<?php echo $label->ID; ?>" title="View label and list of albums it is attached to.">view</a> &#183;
                        <a href="<?php echo $self; ?>?op=edit-label&amp;label_id=<?php echo $label->ID; ?>" title="Edit label details.">edit</a> &#183;
                        <a href="<?php echo $self; ?>?op=delete-label&amp;label_id=<?php echo $label->ID; ?>" title="Delete label.">delete</a>
                        </td> -->
                </tr>

                <?php
            }

            ?>

            </table>
            <p><input class="mysubmit" type="submit" name="Submit" value="Save changes to sort &amp; visibility" /></p>
            </form>

            <?php
        } else {
            ?>

            <h2>Current Labels</h2>
            <p>No labels yet.</p>

            <?php
        }
    ?>

    <h2>Add new label</h2>
    <form name="form1" enctype="multipart/form-data" method="post" action="<?php echo $self; ?>?op=add-label">
    <input name="makecheck" type="hidden" />

    <p><label for="album">Label:</label><br /><input type="text" id="label" name="label" size="32"  /><p><input class="mysubmit" type="submit" name="Submit" value="Add label" /></p>
    </form>

    <?php
        break;
    }







    //* default: list-albums -----------------------------------------------



    default : { //* list-albums 2005-05-21 18:55:55
    // 2005-05-21 15:51:59

        // load all albums
        $sql = "SELECT a.ID, a.title, a.cover_image, u.filename, a.sort_order, a.date_edited, a.visible, a.in_frontpage "
                    ." FROM $table_albums a LEFT JOIN $table_photos p"
                    ." ON a.cover_image=p.ID "
                    ." LEFT JOIN $table_uploads u "
                    ." ON p.upload_id=u.ID "
                    ." ORDER BY a.sort_order DESC";

        $albums = $db->get_results($sql);

        // show variable info
        //ipap_debug($albums);


        if ($albums) {
            ?>

            <h2>Current albums</h2>
            <p>
                <a href="#" onclick="toggleclass('th', 'toggle-sort-column');toggleclass('td', 'toggle-sort-column');return false;">Reorder albums</a> &#183;
                <a href="#" onclick="toggleclass('th', 'toggle-visibility');toggleclass('td', 'toggle-visibility');return false;">Change visibility</a> &#183;
                <a href="#" onclick="toggle('list-albums-help');return false;" title="Hide or show help (below).">Help?</a>
            </p>

            <form enctype="multipart/form-data" method="post" action="<?php echo $self; ?>?op=edit-album-sort">

            <ul id="list-albums-help" style="display:none;">
                <li><strong>Sort Order</strong> &#8594; Display sequence of photo albums. Reversed sort (highest first).</li>
                <li><strong>In frontpage?</strong> &#8594; Check to display album in gallery&#8217;s frontpage.</li>
                <li><strong>Visible?</strong> &#8594; Uncheck this to hide an album.</li>
                <li><strong>Reset cover</strong> &#8594; Use default cover, as set by the sort order of photos in the album. (Lowest sort order value is used as cover.)</li>
                <li><strong>Set custom cover</strong> &#8594; Select a photo as the album&#8217;s cover.</li>
                <li><strong>Upload</strong> &#8594; Add (upload) photos to the given album.</li>
                <li><strong>Edit</strong> &#8594; Edit the album&#8217;s details and contents.</li>
                <li><strong>Delete</strong> &#8594; Delete the album.</li>
            </ul>

            <table width="100%">
            <tr>
                <th class="toggle-sort-column" style="display:none;" width="15%">Sort Order</th>
                <th class="toggle-visibility" style="display:none;" width="15%">In frontpage?</th>
                <th class="toggle-visibility" style="display:none;" width="15%">Visible?</th>
                <th>Album</th>
            </tr>


            <?php
            foreach ($albums as $value) {

                $value->visible == 'Y' ? $checked = 'checked="checked"' : $checked = '';
                $value->in_frontpage == 'Y' ? $checked2 = 'checked="checked"' : $checked2 = '';

                $photo_count = $db->get_var(" SELECT COUNT(*) FROM $table_photos WHERE album_id='$value->ID' AND visible='Y' ");



                if (isset($value->filename)) {
                    $thmb_col = '<img class="right-flush" src="'.$gallery_url.$path_photos.$thumbnail_prefix.$value->filename.'" />';
                    $cover_txt = 'Cover: Custom photo (<a href="'.$self.'?op=reset-cover-photo&amp;album_id='.$value->ID.'">reset cover</a>)';
                } else {
                    $sql = " SELECT ID FROM $table_photos "
                            ." WHERE album_id='$value->ID' "
                            ." ORDER BY sort_order ASC ";
                    $min_id = $db->get_var($sql);

                    $sql = " SELECT u.filename "
                            ." FROM $table_photos p "
                            ." LEFT JOIN $table_uploads u ON p.upload_id=u.ID "
                            ." WHERE p.ID='$min_id' ";
                    $fn = $db->get_var($sql);

                    $thmb_col = '<img class="right-flush" src="'.$gallery_url.$path_photos.$thumbnail_prefix.$fn.'" /><!-- <br /><a href="'.$self.'?op=reset-cover-photo&amp;album_id='.$value->ID.'">reset cover</a><br />(ID sorted) -->';
                    $cover_txt = 'Cover: First photo (<a href="'.$self.'?op=edit-album&amp;album_id='.$value->ID.'">Set custom cover</a>)';
                }


                ?>

                <tr>
                    <td class="toggle-sort-column" style="display:none;"><input type="text" id="sort_<?php echo $value->ID; ?>" name="sort_<?php echo $value->ID; ?>" size="4" value="<?php echo $value->sort_order; ?>" /></td>

                    <td class="toggle-visibility" style="display:none;"><input type="checkbox" id="infrontpage_<?php echo $value->ID; ?>" name="infrontpage_<?php echo $value->ID; ?>" <?php echo $checked2; ?> /></td>

                    <td class="toggle-visibility" style="display:none;"><input type="checkbox" id="visible_<?php echo $value->ID; ?>" name="visible_<?php echo $value->ID; ?>" <?php echo $checked; ?> /></td>

                    <td>
                    <?php echo $thmb_col; ?>
                    <h3><?php echo(texturize($value->title)); ?></h3>
                    <p class="actions">
                        <?php echo $photo_count; ?> photo(s)<br />
                        Last changed: <?php echo(texturize(date($gallery_date_format, strtotime($value->date_edited)))); ?><br />
                        <?php echo $cover_txt; ?><br />
                        <a href="<?php echo $self; ?>?op=upload-to-album&amp;album_id=<?php echo $value->ID; ?>" title="Upload photos to this album.">upload</a> &#183;
                        <a href="<?php echo $self; ?>?op=edit-album&amp;album_id=<?php echo $value->ID; ?>" title="Edit this album&#8217;s details and contents.">edit</a> &#183;
                        <a href="<?php echo $self; ?>?op=delete-album&amp;album_id=<?php echo $value->ID; ?>" title="Delete this album.">delete</a>
                    </p>

                    </td>
                </tr>

                <?php

            }

            ?>

            </table>
            <p>
                <a href="#" onclick="toggleclass('th', 'toggle-sort-column');toggleclass('td', 'toggle-sort-column');return false;">Reorder albums</a> &#183;
                <a href="#" onclick="toggleclass('th', 'toggle-visibility');toggleclass('td', 'toggle-visibility');return false;">Change visibility</a>
            </p>

            <p><input class="mysubmit" type="submit" name="Submit" value="Save changes to sort &amp; visibility" /></p>
            </form>




            <?php

        } else {

            ?>

            <h2>Current albums</h2>
            <p>No albums yet.</p>

            <?php
        }

    ?>

    <h2>Add new album</h2>
    <form name="form1" enctype="multipart/form-data" method="post" action="<?php echo $self; ?>?op=make-album">
    <input name="makecheck" type="hidden" />

    <p><label for="album">Album title:</label><br /><input type="text" id="album" name="album" size="32"  /><p><input class="mysubmit" type="submit" name="Submit" value="Make new album" /></p>
    </form>



    <?php

        break;
    } // end list-albums





} // end switch
















$end = microtime();
echo '<p id="footer">[ '.microtime_diff($end, $start).' seconds &#183; '.$db->num_queries.' queries &#183; '.$ipap_version.' ] ';
echo $html_footer;

?>