<?php

/* the settings below this line are better left untouched.
no user-configurable variables, don't expect answers
if you play with these.
*/
$ipap_force_compile = 0;    // 0 or 1
$ipap_show_timer = 0;       // 0 or 1

$url_zeroise = 5;
$truncate_length = 48;
$allowed_img_type = array(2); // 2 = JPEG, do not touch this line yet!

$path_temp = 'ipap-temp/';
$path_photos = 'ipap-photos/'; // for 0.9 and above
//$path_photos = 'ipap-uploads/'; // for 0.7 users
$path_db = 'ipap-db/';
$path_lib = 'ipap-lib/';
$path_admin = 'ipap-admin/';
$path_templates = 'ipap-templates/';


$table_uploads = $tbl_prefix.'uploads';
$table_photos = $tbl_prefix.'photos';
$table_albums = $tbl_prefix.'albums';
$table_labels = $tbl_prefix.'labels';
$table_labelsrel = $tbl_prefix.'labelsrel';


$gallery_tpl = 'ipap-gallery.tpl.php';
$label_tpl = 'ipap-label.tpl.php';
$album_tpl = 'ipap-album.tpl.php';
$photo_tpl = 'ipap-photo.tpl.php';
$css_tpl = 'ipap-styles.css';

$ipap_info = 'iPAP: Photo Album Publisher';
$ipap_version = 'iPAP 0.9-beta';


$thumbnail_prefix =  't'.$thumbnail_size.'__';

$cache_life = intval($cache_life) * 60; // convert from minutes to seconds
if ($ipap_force_compile) { $cache_life = 0; }





// filters
$filter['album_title'] = array('texturize');
$filter['album_description'] = array('texturize', 'autop');
$filter['album_date_edited'] = array('texturize');
$filter['album_date_created'] = array('texturize');

$filter['photo_title'] = array('texturize');
$filter['photo_caption'] = array('texturize', 'autop');
$filter['photo_date_taken'] = array('texturize');
$filter['photo_date_edited'] = array('texturize');
$filter['photo_date_created'] = array('texturize');

$filter['label_title'] = array('texturize');
$filter['label_description'] = array('texturize', 'autop');




?>