<html><body style="font-family:Georgia, Times, serif;">
<?
/*
ipap-install 2005-05-01 01:44:09
*/
require_once 'ipap-config.php';
require_once $path_lib.'ez_sql.php';

unset($db);
$dbxx = new db($db_username, $db_password, $db_name, $db_host);


function readfile_to_string($filename)
{
            $file = stripslashes($filename);
            $fp = fopen($file, 'r');
            $file_contents = '';
            do {
                $__data = fread($fp, 8192);
                if (strlen($__data) == 0) {
                    break;
                }
                $file_contents .= $__data;
            } while(true);
            fclose($fp);

            $file_contents = substr($file_contents, strpos($file_contents, '?>')+3);
            $db = unserialize(trim($file_contents));

            return $db;
}



function upgrade_db_uploads()
{
    global $dbxx, $table_uploads;
    $db = readfile_to_string('ipap-db/db-uploads.php');
    echo '<p>';
    echo 'Upgrading table <strong>ipap-db/db-uploads.php</strong><br />';
    echo 'The counter is currently at: '.$db['counter'].'<br />';

    foreach ($db['records'] as $row) {

        $sql = " INSERT INTO $table_uploads SET "
                ." ID='".$row['id']."', "
                ." filename='".mysql_escape_string($row['filename'])."', "
                ." width='".$row['width']."', "
                ." height='".$row['height']."', "
                ." date_uploaded='".$row['date_uploaded']."' ";

        $dbxx->query($sql);
    }

    if ($dbxx->rows_affected > 0) {
            echo 'Import successful.<br />';
    }
    echo '</p>';
}





function upgrade_db_photos()
{
    global $dbxx, $table_photos;
    $db = readfile_to_string('ipap-db/db-photos.php');
    echo '<p>';
    echo 'Upgrading table <strong>ipap-db/db-photos.php</strong><br />';
    echo 'The counter is currently at: '.$db['counter'].'<br />';


    foreach ($db['records'] as $row) {

        $visible = 'N';
        if ($row['visible'] == 1) {
            $visible = 'Y';
        }

        $sql = " INSERT INTO $table_photos SET "
                ." ID='".$row['id']."', "
                ." upload_id='".$row['upload_id']."', "
                ." album_id='".$row['album_id']."', "
                ." sort_order='".$row['sort_order']."', "
                ." title='".mysql_escape_string($row['title'])."', "
                ." caption='".mysql_escape_string($row['caption'])."', "
                ." visible='".$visible."', "
                ." date_taken='".$row['date_taken']."', "
                ." date_created='".$row['date_created']."', "
                ." date_edited='".$row['date_edited']."' ";

        $dbxx->query($sql);
    }

    if ($dbxx->rows_affected > 0) {
            echo 'Import successful.<br />';
    }
    echo '</p>';
}







function upgrade_db_albums()
{
    global $dbxx, $table_albums;
    $db = readfile_to_string('ipap-db/db-albums.php');
    echo '<p>';
    echo 'Upgrading table <strong>ipap-db/db-albums.php</strong><br />';
    echo 'The counter is currently at: '.$db['counter'].'<br />';


    foreach ($db['records'] as $row) {


        $visible = 'N';
        if ($row['visible'] == 1) {
            $visible = 'Y';
        }

        $fp = 'N';
        if ($row['in_frontpage'] == 1) {
            $fp = 'Y';
        }

        $sql = " INSERT INTO $table_albums SET "
                ." ID='".$row['id']."', "
                ." sort_order='".$row['sort_order']."', "
                ." title='".mysql_escape_string($row['title'])."', "
                ." description='".mysql_escape_string($row['description'])."', "
                ." cover_image='".$row['cover_image']."', "
                ." slug='".$row['slug']."', "
                ." visible='".$visible."', "
                ." in_frontpage='".$fp."', "
                ." date_created='".$row['date_created']."', "
                ." date_edited='".$row['date_edited']."' ";


        $dbxx->query($sql);
    }

    if ($dbxx->rows_affected > 0) {
            echo 'Import successful.<br />';
    }
    echo '</p>';
}











if (  isset($_REQUEST["enabled"])  ) {

    upgrade_db_uploads();
    upgrade_db_photos();
    upgrade_db_albums();

} else {
    echo '<a href="'.$PHP_SELF.'?enabled=1">Upgrade from old database format</a>.';
}
?>
</body></html>